/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* vim:set ts=2 sw=2 sts=2 et cindent: */
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

/* THIS FILE IS AUTOGENERATED FROM ServiceWorkerMessageEvent.webidl BY Codegen.py - DO NOT EDIT */

#include "EventBinding.h"
#include "ServiceWorkerMessageEvent.h"
#include "ServiceWorkerMessageEventBinding.h"
#include "js/GCAPI.h"
#include "mozilla/dom/MessagePort.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/ServiceWorkerMessageEvent.h"
#include "mozilla/dom/UnionConversions.h"

namespace mozilla {
namespace dom {


NS_IMPL_CYCLE_COLLECTION_CLASS(ServiceWorkerMessageEvent)

NS_IMPL_ADDREF_INHERITED(ServiceWorkerMessageEvent, Event)
NS_IMPL_RELEASE_INHERITED(ServiceWorkerMessageEvent, Event)

NS_IMPL_CYCLE_COLLECTION_TRAVERSE_BEGIN_INHERITED(ServiceWorkerMessageEvent, Event)
  NS_IMPL_CYCLE_COLLECTION_TRAVERSE(mSource)
  NS_IMPL_CYCLE_COLLECTION_TRAVERSE(mPorts)
NS_IMPL_CYCLE_COLLECTION_TRAVERSE_END

NS_IMPL_CYCLE_COLLECTION_TRACE_BEGIN_INHERITED(ServiceWorkerMessageEvent, Event)
  NS_IMPL_CYCLE_COLLECTION_TRACE_JS_MEMBER_CALLBACK(mData)
NS_IMPL_CYCLE_COLLECTION_TRACE_END

NS_IMPL_CYCLE_COLLECTION_UNLINK_BEGIN_INHERITED(ServiceWorkerMessageEvent, Event)
  tmp->mData.setUndefined();
  NS_IMPL_CYCLE_COLLECTION_UNLINK(mSource)
  NS_IMPL_CYCLE_COLLECTION_UNLINK(mPorts)
NS_IMPL_CYCLE_COLLECTION_UNLINK_END

NS_INTERFACE_MAP_BEGIN_CYCLE_COLLECTION_INHERITED(ServiceWorkerMessageEvent)
NS_INTERFACE_MAP_END_INHERITING(Event)

ServiceWorkerMessageEvent::ServiceWorkerMessageEvent(mozilla::dom::EventTarget* aOwner)
  : Event(aOwner, nullptr, nullptr)
{
}

ServiceWorkerMessageEvent::~ServiceWorkerMessageEvent()
{
  mData = JS::UndefinedValue();
  mozilla::DropJSObjects(this);
}

void
ServiceWorkerMessageEvent::GetData(JS::MutableHandle<JS::Value> aRetVal) const
{
  JS::ExposeValueToActiveJS(mData);
  aRetVal.set(mData);
}

ServiceWorkerMessageEvent*
ServiceWorkerMessageEvent::AsServiceWorkerMessageEvent()
{
  return this;
}

JSObject*
ServiceWorkerMessageEvent::WrapObjectInternal(JSContext* aCx, JS::Handle<JSObject*> aGivenProto)
{
  return ServiceWorkerMessageEventBinding::Wrap(aCx, this, aGivenProto);
}

already_AddRefed<ServiceWorkerMessageEvent>
ServiceWorkerMessageEvent::Constructor(mozilla::dom::EventTarget* aOwner, const nsAString& aType, const ServiceWorkerMessageEventInit& aEventInitDict)
{
  RefPtr<ServiceWorkerMessageEvent> e = new ServiceWorkerMessageEvent(aOwner);
  bool trusted = e->Init(aOwner);
  e->InitEvent(aType, aEventInitDict.mBubbles, aEventInitDict.mCancelable);
  e->mData = aEventInitDict.mData;
  e->mOrigin = aEventInitDict.mOrigin;
  e->mLastEventId = aEventInitDict.mLastEventId;
  e->mSource = aEventInitDict.mSource;
  e->mPorts.AppendElements(aEventInitDict.mPorts);
  e->SetTrusted(trusted);
  e->SetComposed(aEventInitDict.mComposed);
  mozilla::HoldJSObjects(e.get());
  return e.forget();
}

already_AddRefed<ServiceWorkerMessageEvent>
ServiceWorkerMessageEvent::Constructor(const GlobalObject& aGlobal, const nsAString& aType, const ServiceWorkerMessageEventInit& aEventInitDict, ErrorResult& aRv)
{
  nsCOMPtr<mozilla::dom::EventTarget> owner = do_QueryInterface(aGlobal.GetAsSupports());
  return Constructor(owner, aType, aEventInitDict);
}

void
ServiceWorkerMessageEvent::GetData(JSContext* cx, JS::MutableHandle<JS::Value> aRetVal) const
{
  GetData(aRetVal);
}

void
ServiceWorkerMessageEvent::GetOrigin(nsString& aRetVal) const
{
  aRetVal = mOrigin;
}

void
ServiceWorkerMessageEvent::GetLastEventId(nsString& aRetVal) const
{
  aRetVal = mLastEventId;
}

void
ServiceWorkerMessageEvent::GetSource(Nullable<OwningServiceWorkerOrMessagePort>& aRetVal) const
{
  aRetVal = mSource;
}

void
ServiceWorkerMessageEvent::GetPorts(nsTArray<RefPtr<MessagePort>>& aRetVal) const
{
  aRetVal = mPorts;
}


} // namespace dom
} // namespace mozilla
