//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PCamerasParent_h
#define PCamerasParent_h

#include "mozilla/camera/PCameras.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/media/CamerasTypes.h"

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace camera {


class PCamerasParent :
    public mozilla::ipc::IProtocol
{
    friend class mozilla::ipc::PBackgroundParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::camera::CaptureCapability CaptureCapability;
    typedef mozilla::camera::CaptureEngine CaptureEngine;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef mozilla::ipc::PBackgroundParent PBackgroundParent;
    typedef mozilla::ipc::PBackgroundChild PBackgroundChild;

    typedef PCameras::State State;

    virtual bool
    RecvNumberOfCaptureDevices(const CaptureEngine& engine) = 0;
    virtual bool
    RecvNumberOfCapabilities(
            const CaptureEngine& engine,
            const nsCString& deviceUniqueIdUTF8) = 0;
    virtual bool
    RecvGetCaptureCapability(
            const CaptureEngine& engine,
            const nsCString& unique_idUTF8,
            const int& capability_number) = 0;
    virtual bool
    RecvGetCaptureDevice(
            const CaptureEngine& engine,
            const int& num) = 0;
    virtual bool
    RecvAllocateCaptureDevice(
            const CaptureEngine& engine,
            const nsCString& unique_idUTF8,
            const nsCString& origin) = 0;
    virtual bool
    RecvReleaseCaptureDevice(
            const CaptureEngine& engine,
            const int& numdev) = 0;
    virtual bool
    RecvStartCapture(
            const CaptureEngine& engine,
            const int& numdev,
            const CaptureCapability& capability) = 0;
    virtual bool
    RecvStopCapture(
            const CaptureEngine& engine,
            const int& numdev) = 0;
    virtual bool
    RecvReleaseFrame(Shmem&& s) = 0;
    virtual bool
    RecvAllDone() = 0;
    virtual bool
    RecvEnsureInitialized(const CaptureEngine& engine) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    MOZ_IMPLICIT PCamerasParent();

    virtual ~PCamerasParent();

    PBackgroundParent*
    Manager() const;

    PCameras::State
    state();

    MOZ_MUST_USE bool
    SendFrameSizeChange(
            const CaptureEngine& capEngine,
            const int& cap_id,
            const int& w,
            const int& h);

    MOZ_MUST_USE bool
    SendDeliverFrame(
            const CaptureEngine& capEngine,
            const int& cap_id,
            Shmem& buffer,
            const size_t& size,
            const uint32_t& time_stamp,
            const int64_t& ntp_time,
            const int64_t& render_time);

    MOZ_MUST_USE bool
    SendDeviceChange();

    MOZ_MUST_USE bool
    SendReplyNumberOfCaptureDevices(const int& numdev);

    MOZ_MUST_USE bool
    SendReplyNumberOfCapabilities(const int& numdev);

    MOZ_MUST_USE bool
    SendReplyAllocateCaptureDevice(const int& numdev);

    MOZ_MUST_USE bool
    SendReplyGetCaptureCapability(const CaptureCapability& cap);

    MOZ_MUST_USE bool
    SendReplyGetCaptureDevice(
            const nsCString& device_name,
            const nsCString& device_id,
            const bool& scary);

    MOZ_MUST_USE bool
    SendReplyFailure();

    MOZ_MUST_USE bool
    SendReplySuccess();

    MOZ_MUST_USE static bool
    Send__delete__(PCamerasParent* actor);

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const CaptureCapability& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            CaptureCapability* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PCamerasParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PCamerasParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            Shmem& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            Shmem* v__,
            const Message* msg__,
            PickleIterator* iter__);

    State mState;
};


} // namespace camera
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace camera {
class CamerasParent :
    public PCamerasParent
{
    virtual bool
    RecvNumberOfCaptureDevices(const CaptureEngine& engine);

    virtual bool
    RecvNumberOfCapabilities(
            const CaptureEngine& engine,
            const nsCString& deviceUniqueIdUTF8);

    virtual bool
    RecvGetCaptureCapability(
            const CaptureEngine& engine,
            const nsCString& unique_idUTF8,
            const int& capability_number);

    virtual bool
    RecvGetCaptureDevice(
            const CaptureEngine& engine,
            const int& num);

    virtual bool
    RecvAllocateCaptureDevice(
            const CaptureEngine& engine,
            const nsCString& unique_idUTF8,
            const nsCString& origin);

    virtual bool
    RecvReleaseCaptureDevice(
            const CaptureEngine& engine,
            const int& numdev);

    virtual bool
    RecvStartCapture(
            const CaptureEngine& engine,
            const int& numdev,
            const CaptureCapability& capability);

    virtual bool
    RecvStopCapture(
            const CaptureEngine& engine,
            const int& numdev);

    virtual bool
    RecvReleaseFrame(Shmem&& s);

    virtual bool
    RecvAllDone();

    virtual bool
    RecvEnsureInitialized(const CaptureEngine& engine);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT CamerasParent();
    virtual ~CamerasParent();
};
} // namespace camera
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace camera {
bool
CamerasParent::RecvNumberOfCaptureDevices(const CaptureEngine& engine)
{
    return false;
}

bool
CamerasParent::RecvNumberOfCapabilities(
        const CaptureEngine& engine,
        const nsCString& deviceUniqueIdUTF8)
{
    return false;
}

bool
CamerasParent::RecvGetCaptureCapability(
        const CaptureEngine& engine,
        const nsCString& unique_idUTF8,
        const int& capability_number)
{
    return false;
}

bool
CamerasParent::RecvGetCaptureDevice(
        const CaptureEngine& engine,
        const int& num)
{
    return false;
}

bool
CamerasParent::RecvAllocateCaptureDevice(
        const CaptureEngine& engine,
        const nsCString& unique_idUTF8,
        const nsCString& origin)
{
    return false;
}

bool
CamerasParent::RecvReleaseCaptureDevice(
        const CaptureEngine& engine,
        const int& numdev)
{
    return false;
}

bool
CamerasParent::RecvStartCapture(
        const CaptureEngine& engine,
        const int& numdev,
        const CaptureCapability& capability)
{
    return false;
}

bool
CamerasParent::RecvStopCapture(
        const CaptureEngine& engine,
        const int& numdev)
{
    return false;
}

bool
CamerasParent::RecvReleaseFrame(Shmem&& s)
{
    return false;
}

bool
CamerasParent::RecvAllDone()
{
    return false;
}

bool
CamerasParent::RecvEnsureInitialized(const CaptureEngine& engine)
{
    return false;
}

void
CamerasParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT CamerasParent::CamerasParent()
{
    MOZ_COUNT_CTOR(CamerasParent);
}

MOZ_IMPLICIT CamerasParent::~CamerasParent()
{
    MOZ_COUNT_DTOR(CamerasParent);
}

} // namespace camera
} // namespace mozilla
#endif // if 0

#endif // ifndef PCamerasParent_h
