//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PBrowser_h
#define PBrowser_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "ipc/IPCMessageUtils.h"
#include "mozilla/EventForwards.h"
#include "mozilla/dom/DOMTypes.h"
#include "mozilla/jsipc/JavaScriptTypes.h"
#include "mozilla/ipc/URIParams.h"
#include "mozilla/embedding/PPrintingTypes.h"
#include "mozilla/dom/PTabContext.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct NativeKeyBinding|
//
namespace mozilla {
namespace dom {
class NativeKeyBinding final
{
private:
    typedef mozilla::CommandInt CommandInt;

public:
    MOZ_IMPLICIT NativeKeyBinding();

    MOZ_IMPLICIT NativeKeyBinding(
            const nsTArray<CommandInt>& _singleLineCommands,
            const nsTArray<CommandInt>& _multiLineCommands,
            const nsTArray<CommandInt>& _richTextCommands)
    {
        Init();
        Assign(_singleLineCommands, _multiLineCommands, _richTextCommands);
    }

    MOZ_IMPLICIT NativeKeyBinding(const NativeKeyBinding& _o)
    {
        Init();
        Assign((_o).singleLineCommands(), (_o).multiLineCommands(), (_o).richTextCommands());
    }

    ~NativeKeyBinding();

    void
    operator=(const NativeKeyBinding& _o)
    {
        Assign((_o).singleLineCommands(), (_o).multiLineCommands(), (_o).richTextCommands());
    }

    bool
    operator==(const NativeKeyBinding& _o) const;

    nsTArray<CommandInt>&
    singleLineCommands()
    {
        return singleLineCommands_;
    }
    const nsTArray<CommandInt>&
    singleLineCommands() const
    {
        return singleLineCommands_;
    }

    nsTArray<CommandInt>&
    multiLineCommands()
    {
        return multiLineCommands_;
    }
    const nsTArray<CommandInt>&
    multiLineCommands() const
    {
        return multiLineCommands_;
    }

    nsTArray<CommandInt>&
    richTextCommands()
    {
        return richTextCommands_;
    }
    const nsTArray<CommandInt>&
    richTextCommands() const
    {
        return richTextCommands_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsTArray<CommandInt>& _singleLineCommands,
            const nsTArray<CommandInt>& _multiLineCommands,
            const nsTArray<CommandInt>& _richTextCommands);

    nsTArray<CommandInt> singleLineCommands_;
    nsTArray<CommandInt> multiLineCommands_;
    nsTArray<CommandInt> richTextCommands_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class NativeKeyBinding;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union MaybeNativeKeyBinding|
//
namespace mozilla {
namespace dom {
class MaybeNativeKeyBinding final
{
public:
    enum Type {
        T__None,
        TNativeKeyBinding = 1,
        Tvoid_t,
        T__Last = Tvoid_t
    };

private:
    typedef mozilla::dom::NativeKeyBinding NativeKeyBinding;
    typedef mozilla::void_t void_t;
    typedef NativeKeyBinding NativeKeyBinding__tdef;
    typedef void_t void_t__tdef;

    union Value {
        mozilla::AlignedStorage2<NativeKeyBinding> VNativeKeyBinding;
        mozilla::AlignedStorage2<void_t> Vvoid_t;
    };

    NativeKeyBinding*
    ptr_NativeKeyBinding()
    {
        return ((mValue).VNativeKeyBinding).addr();
    }
    const NativeKeyBinding*
    constptr_NativeKeyBinding() const
    {
        return ((mValue).VNativeKeyBinding).addr();
    }
    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT MaybeNativeKeyBinding() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT MaybeNativeKeyBinding(const NativeKeyBinding& aOther);

    MOZ_IMPLICIT MaybeNativeKeyBinding(const void_t& aOther);

    MOZ_IMPLICIT MaybeNativeKeyBinding(const MaybeNativeKeyBinding& aOther);

    ~MaybeNativeKeyBinding();

    Type
    type() const
    {
        return mType;
    }

    MaybeNativeKeyBinding&
    operator=(const NativeKeyBinding& aRhs);

    MaybeNativeKeyBinding&
    operator=(const void_t& aRhs);

    MaybeNativeKeyBinding&
    operator=(const MaybeNativeKeyBinding& aRhs);

    bool
    operator==(const NativeKeyBinding& aRhs) const;

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const MaybeNativeKeyBinding& aRhs) const;

    NativeKeyBinding&
    get_NativeKeyBinding()
    {
        AssertSanity(TNativeKeyBinding);
        return (*(ptr_NativeKeyBinding()));
    }
    const NativeKeyBinding&
    get_NativeKeyBinding() const
    {
        AssertSanity(TNativeKeyBinding);
        return (*(constptr_NativeKeyBinding()));
    }
    void
    get(NativeKeyBinding* aOutValue) const;
    operator NativeKeyBinding&()
    {
        return get_NativeKeyBinding();
    }
    operator const NativeKeyBinding&() const
    {
        return get_NativeKeyBinding();
    }

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    void
    get(void_t* aOutValue) const;
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ShowInfo|
//
namespace mozilla {
namespace dom {
class ShowInfo final
{
private:

public:
    MOZ_IMPLICIT ShowInfo();

    MOZ_IMPLICIT ShowInfo(
            const nsString& _name,
            const bool& _fullscreenAllowed,
            const bool& _isPrivate,
            const bool& _fakeShowInfo,
            const bool& _isTransparent,
            const float& _dpi,
            const int32_t& _widgetRounding,
            const double& _defaultScale)
    {
        Init();
        Assign(_name, _fullscreenAllowed, _isPrivate, _fakeShowInfo, _isTransparent, _dpi, _widgetRounding, _defaultScale);
    }

    MOZ_IMPLICIT ShowInfo(const ShowInfo& _o)
    {
        Init();
        Assign((_o).name(), (_o).fullscreenAllowed(), (_o).isPrivate(), (_o).fakeShowInfo(), (_o).isTransparent(), (_o).dpi(), (_o).widgetRounding(), (_o).defaultScale());
    }

    ~ShowInfo();

    void
    operator=(const ShowInfo& _o)
    {
        Assign((_o).name(), (_o).fullscreenAllowed(), (_o).isPrivate(), (_o).fakeShowInfo(), (_o).isTransparent(), (_o).dpi(), (_o).widgetRounding(), (_o).defaultScale());
    }

    bool
    operator==(const ShowInfo& _o) const;

    nsString&
    name()
    {
        return name_;
    }
    const nsString&
    name() const
    {
        return name_;
    }

    bool&
    fullscreenAllowed()
    {
        return fullscreenAllowed_;
    }
    const bool&
    fullscreenAllowed() const
    {
        return fullscreenAllowed_;
    }

    bool&
    isPrivate()
    {
        return isPrivate_;
    }
    const bool&
    isPrivate() const
    {
        return isPrivate_;
    }

    bool&
    fakeShowInfo()
    {
        return fakeShowInfo_;
    }
    const bool&
    fakeShowInfo() const
    {
        return fakeShowInfo_;
    }

    bool&
    isTransparent()
    {
        return isTransparent_;
    }
    const bool&
    isTransparent() const
    {
        return isTransparent_;
    }

    float&
    dpi()
    {
        return dpi_;
    }
    const float&
    dpi() const
    {
        return dpi_;
    }

    int32_t&
    widgetRounding()
    {
        return widgetRounding_;
    }
    const int32_t&
    widgetRounding() const
    {
        return widgetRounding_;
    }

    double&
    defaultScale()
    {
        return defaultScale_;
    }
    const double&
    defaultScale() const
    {
        return defaultScale_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _name,
            const bool& _fullscreenAllowed,
            const bool& _isPrivate,
            const bool& _fakeShowInfo,
            const bool& _isTransparent,
            const float& _dpi,
            const int32_t& _widgetRounding,
            const double& _defaultScale);

    nsString name_;
    bool fullscreenAllowed_;
    bool isPrivate_;
    bool fakeShowInfo_;
    bool isTransparent_;
    float dpi_;
    int32_t widgetRounding_;
    double defaultScale_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalShmem|
//
namespace mozilla {
namespace dom {
class OptionalShmem final
{
public:
    enum Type {
        T__None,
        Tvoid_t = 1,
        TShmem,
        T__Last = TShmem
    };

private:
    typedef mozilla::void_t void_t;
    typedef mozilla::ipc::Shmem Shmem;
    typedef void_t void_t__tdef;
    typedef Shmem Shmem__tdef;

    union Value {
        mozilla::AlignedStorage2<void_t> Vvoid_t;
        mozilla::AlignedStorage2<Shmem> VShmem;
    };

    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }
    Shmem*
    ptr_Shmem()
    {
        return ((mValue).VShmem).addr();
    }
    const Shmem*
    constptr_Shmem() const
    {
        return ((mValue).VShmem).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalShmem() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalShmem(const void_t& aOther);

    MOZ_IMPLICIT OptionalShmem(Shmem& aOther);

    MOZ_IMPLICIT OptionalShmem(const OptionalShmem& aOther);

    ~OptionalShmem();

    Type
    type() const
    {
        return mType;
    }

    OptionalShmem&
    operator=(const void_t& aRhs);

    OptionalShmem&
    operator=(Shmem& aRhs);

    OptionalShmem&
    operator=(const OptionalShmem& aRhs);

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(Shmem& aRhs) const;

    bool
    operator==(const OptionalShmem& aRhs) const;

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    void
    get(void_t* aOutValue) const;
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

    Shmem&
    get_Shmem()
    {
        AssertSanity(TShmem);
        return (*(ptr_Shmem()));
    }
    Shmem&
    get_Shmem() const
    {
        AssertSanity(TShmem);
        return const_cast<Shmem&>((*(constptr_Shmem())));
    }
    void
    get(Shmem* aOutValue) const;
    operator Shmem&()
    {
        return get_Shmem();
    }
    operator Shmem&() const
    {
        return get_Shmem();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PBrowserChild;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PBrowserChild and PBrowserParent
//
namespace mozilla {
namespace dom {
namespace PBrowser {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::dom::PBrowserParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::dom::PBrowserChild>* aChild);

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PBrowserStart = PBrowserMsgStart << 16,
    Msg_AsyncMessage__ID,
    Msg_PRenderFrameConstructor__ID,
    Reply_PRenderFrameConstructor__ID,
    Msg_PDocAccessibleConstructor__ID,
    Reply_PDocAccessibleConstructor__ID,
    Msg_PPluginWidgetConstructor__ID,
    Reply_PPluginWidgetConstructor__ID,
    Msg_GetWidgetNativeData__ID,
    Reply_GetWidgetNativeData__ID,
    Msg_SetNativeChildOfShareableWindow__ID,
    Msg_DispatchFocusToTopLevelWindow__ID,
    Reply_DispatchFocusToTopLevelWindow__ID,
    Msg_MoveFocus__ID,
    Msg_SizeShellTo__ID,
    Msg_DropLinks__ID,
    Msg_Event__ID,
    Msg_SyncMessage__ID,
    Reply_SyncMessage__ID,
    Msg_RpcMessage__ID,
    Reply_RpcMessage__ID,
    Msg_NotifyIMEFocus__ID,
    Reply_NotifyIMEFocus__ID,
    Msg_NotifyIMETextChange__ID,
    Msg_NotifyIMECompositionUpdate__ID,
    Msg_NotifyIMESelection__ID,
    Msg_UpdateContentCache__ID,
    Msg_NotifyIMEMouseButtonEvent__ID,
    Reply_NotifyIMEMouseButtonEvent__ID,
    Msg_NotifyIMEPositionChange__ID,
    Msg_RequestIMEToCommitComposition__ID,
    Reply_RequestIMEToCommitComposition__ID,
    Msg_OnEventNeedingAckHandled__ID,
    Msg_StartPluginIME__ID,
    Reply_StartPluginIME__ID,
    Msg_SetPluginFocused__ID,
    Msg_SetCandidateWindowForPlugin__ID,
    Msg_OnWindowedPluginKeyEvent__ID,
    Msg_DefaultProcOfPluginEvent__ID,
    Msg_RequestFocus__ID,
    Msg_EnableDisableCommands__ID,
    Msg_GetInputContext__ID,
    Reply_GetInputContext__ID,
    Msg_SetInputContext__ID,
    Msg_IsParentWindowMainWidgetVisible__ID,
    Reply_IsParentWindowMainWidgetVisible__ID,
    Msg_GetDPI__ID,
    Reply_GetDPI__ID,
    Msg_GetDefaultScale__ID,
    Reply_GetDefaultScale__ID,
    Msg_GetWidgetRounding__ID,
    Reply_GetWidgetRounding__ID,
    Msg_GetMaxTouchPoints__ID,
    Reply_GetMaxTouchPoints__ID,
    Msg_SetCursor__ID,
    Msg_SetCustomCursor__ID,
    Msg_SetStatus__ID,
    Msg_ShowTooltip__ID,
    Msg_HideTooltip__ID,
    Msg_PColorPickerConstructor__ID,
    Reply_PColorPickerConstructor__ID,
    Msg_PDatePickerConstructor__ID,
    Reply_PDatePickerConstructor__ID,
    Msg_PFilePickerConstructor__ID,
    Reply_PFilePickerConstructor__ID,
    Msg_PIndexedDBPermissionRequestConstructor__ID,
    Reply_PIndexedDBPermissionRequestConstructor__ID,
    Msg_BrowserFrameOpenWindow__ID,
    Reply_BrowserFrameOpenWindow__ID,
    Msg_RespondStartSwipeEvent__ID,
    Msg_AsyncAuthPrompt__ID,
    Msg_LookUpDictionary__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_ReplyKeyEvent__ID,
    Msg_DispatchAfterKeyboardEvent__ID,
    Msg_RequestNativeKeyBindings__ID,
    Reply_RequestNativeKeyBindings__ID,
    Msg_SynthesizeNativeKeyEvent__ID,
    Msg_SynthesizeNativeMouseEvent__ID,
    Msg_SynthesizeNativeMouseMove__ID,
    Msg_SynthesizeNativeMouseScrollEvent__ID,
    Msg_SynthesizeNativeTouchPoint__ID,
    Msg_SynthesizeNativeTouchTap__ID,
    Msg_ClearNativeTouchSequence__ID,
    Msg_GetTabCount__ID,
    Reply_GetTabCount__ID,
    Msg_AccessKeyNotHandled__ID,
    Msg_NativeSynthesisResponse__ID,
    Msg_RemotePaintIsReady__ID,
    Msg_ForcePaintNoOp__ID,
    Msg_SetDimensions__ID,
    Msg_DispatchWheelEvent__ID,
    Reply_DispatchWheelEvent__ID,
    Msg_DispatchMouseEvent__ID,
    Reply_DispatchMouseEvent__ID,
    Msg_DispatchKeyboardEvent__ID,
    Reply_DispatchKeyboardEvent__ID,
    Msg_InvokeDragSession__ID,
    Msg_AudioChannelActivityNotification__ID,
    Msg_EnsureLayersConnected__ID,
    Reply_EnsureLayersConnected__ID,
    Msg_NotifySessionHistoryChange__ID,
    Msg_RequestCrossBrowserNavigation__ID,
    Msg_Show__ID,
    Msg_LoadURL__ID,
    Msg_UpdateDimensions__ID,
    Msg_SizeModeChanged__ID,
    Msg_Activate__ID,
    Msg_Deactivate__ID,
    Msg_ParentActivated__ID,
    Msg_SetKeyboardIndicators__ID,
    Msg_StopIMEStateManagement__ID,
    Msg_MenuKeyboardListenerInstalled__ID,
    Msg_MouseEvent__ID,
    Msg_RealMouseMoveEvent__ID,
    Msg_SynthMouseMoveEvent__ID,
    Msg_RealMouseButtonEvent__ID,
    Msg_RealKeyEvent__ID,
    Msg_MouseWheelEvent__ID,
    Msg_RealTouchEvent__ID,
    Msg_HandleTap__ID,
    Msg_RealTouchMoveEvent__ID,
    Msg_RealDragEvent__ID,
    Msg_PluginEvent__ID,
    Msg_KeyEvent__ID,
    Msg_CompositionEvent__ID,
    Msg_SelectionEvent__ID,
    Msg_PasteTransferable__ID,
    Msg_ActivateFrameEvent__ID,
    Msg_LoadRemoteScript__ID,
    Msg_Destroy__ID,
    Msg_SetDocShellIsActive__ID,
    Msg_SuppressDisplayport__ID,
    Msg_NavigateByKey__ID,
    Msg_RequestNotifyAfterRemotePaint__ID,
    Msg_UIResolutionChanged__ID,
    Msg_ThemeChanged__ID,
    Msg_SwappedWithOtherRemoteLoader__ID,
    Msg_HandleAccessKey__ID,
    Msg_AudioChannelChangeNotification__ID,
    Msg_SetUseGlobalHistory__ID,
    Msg_HandledWindowedPluginKeyEvent__ID,
    Msg_Print__ID,
    Msg_UpdateNativeWindowHandle__ID,
    Msg_NotifyAttachGroupedSessionHistory__ID,
    Msg_NotifyPartialSessionHistoryActive__ID,
    Msg_NotifyPartialSessionHistoryDeactive__ID,
    Msg_SetFreshProcess__ID,
    PBrowserEnd
};

bool
Transition(
        mozilla::ipc::Trigger trigger,
        State* next);

IPC::Message*
Msg_AsyncMessage(int32_t routingId);

IPC::Message*
Msg_PRenderFrameConstructor(int32_t routingId);
IPC::Message*
Reply_PRenderFrameConstructor(int32_t routingId);

IPC::Message*
Msg_PDocAccessibleConstructor(int32_t routingId);
IPC::Message*
Reply_PDocAccessibleConstructor(int32_t routingId);

IPC::Message*
Msg_PPluginWidgetConstructor(int32_t routingId);
IPC::Message*
Reply_PPluginWidgetConstructor(int32_t routingId);

IPC::Message*
Msg_GetWidgetNativeData(int32_t routingId);
IPC::Message*
Reply_GetWidgetNativeData(int32_t routingId);

IPC::Message*
Msg_SetNativeChildOfShareableWindow(int32_t routingId);

IPC::Message*
Msg_DispatchFocusToTopLevelWindow(int32_t routingId);
IPC::Message*
Reply_DispatchFocusToTopLevelWindow(int32_t routingId);

IPC::Message*
Msg_MoveFocus(int32_t routingId);

IPC::Message*
Msg_SizeShellTo(int32_t routingId);

IPC::Message*
Msg_DropLinks(int32_t routingId);

IPC::Message*
Msg_Event(int32_t routingId);

IPC::Message*
Msg_SyncMessage(int32_t routingId);
IPC::Message*
Reply_SyncMessage(int32_t routingId);

IPC::Message*
Msg_RpcMessage(int32_t routingId);
IPC::Message*
Reply_RpcMessage(int32_t routingId);

IPC::Message*
Msg_NotifyIMEFocus(int32_t routingId);
IPC::Message*
Reply_NotifyIMEFocus(int32_t routingId);

IPC::Message*
Msg_NotifyIMETextChange(int32_t routingId);

IPC::Message*
Msg_NotifyIMECompositionUpdate(int32_t routingId);

IPC::Message*
Msg_NotifyIMESelection(int32_t routingId);

IPC::Message*
Msg_UpdateContentCache(int32_t routingId);

IPC::Message*
Msg_NotifyIMEMouseButtonEvent(int32_t routingId);
IPC::Message*
Reply_NotifyIMEMouseButtonEvent(int32_t routingId);

IPC::Message*
Msg_NotifyIMEPositionChange(int32_t routingId);

IPC::Message*
Msg_RequestIMEToCommitComposition(int32_t routingId);
IPC::Message*
Reply_RequestIMEToCommitComposition(int32_t routingId);

IPC::Message*
Msg_OnEventNeedingAckHandled(int32_t routingId);

IPC::Message*
Msg_StartPluginIME(int32_t routingId);
IPC::Message*
Reply_StartPluginIME(int32_t routingId);

IPC::Message*
Msg_SetPluginFocused(int32_t routingId);

IPC::Message*
Msg_SetCandidateWindowForPlugin(int32_t routingId);

IPC::Message*
Msg_OnWindowedPluginKeyEvent(int32_t routingId);

IPC::Message*
Msg_DefaultProcOfPluginEvent(int32_t routingId);

IPC::Message*
Msg_RequestFocus(int32_t routingId);

IPC::Message*
Msg_EnableDisableCommands(int32_t routingId);

IPC::Message*
Msg_GetInputContext(int32_t routingId);
IPC::Message*
Reply_GetInputContext(int32_t routingId);

IPC::Message*
Msg_SetInputContext(int32_t routingId);

IPC::Message*
Msg_IsParentWindowMainWidgetVisible(int32_t routingId);
IPC::Message*
Reply_IsParentWindowMainWidgetVisible(int32_t routingId);

IPC::Message*
Msg_GetDPI(int32_t routingId);
IPC::Message*
Reply_GetDPI(int32_t routingId);

IPC::Message*
Msg_GetDefaultScale(int32_t routingId);
IPC::Message*
Reply_GetDefaultScale(int32_t routingId);

IPC::Message*
Msg_GetWidgetRounding(int32_t routingId);
IPC::Message*
Reply_GetWidgetRounding(int32_t routingId);

IPC::Message*
Msg_GetMaxTouchPoints(int32_t routingId);
IPC::Message*
Reply_GetMaxTouchPoints(int32_t routingId);

IPC::Message*
Msg_SetCursor(int32_t routingId);

IPC::Message*
Msg_SetCustomCursor(int32_t routingId);

IPC::Message*
Msg_SetStatus(int32_t routingId);

IPC::Message*
Msg_ShowTooltip(int32_t routingId);

IPC::Message*
Msg_HideTooltip(int32_t routingId);

IPC::Message*
Msg_PColorPickerConstructor(int32_t routingId);
IPC::Message*
Reply_PColorPickerConstructor(int32_t routingId);

IPC::Message*
Msg_PDatePickerConstructor(int32_t routingId);
IPC::Message*
Reply_PDatePickerConstructor(int32_t routingId);

IPC::Message*
Msg_PFilePickerConstructor(int32_t routingId);
IPC::Message*
Reply_PFilePickerConstructor(int32_t routingId);

IPC::Message*
Msg_PIndexedDBPermissionRequestConstructor(int32_t routingId);
IPC::Message*
Reply_PIndexedDBPermissionRequestConstructor(int32_t routingId);

IPC::Message*
Msg_BrowserFrameOpenWindow(int32_t routingId);
IPC::Message*
Reply_BrowserFrameOpenWindow(int32_t routingId);

IPC::Message*
Msg_RespondStartSwipeEvent(int32_t routingId);

IPC::Message*
Msg_AsyncAuthPrompt(int32_t routingId);

IPC::Message*
Msg_LookUpDictionary(int32_t routingId);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);

IPC::Message*
Msg_ReplyKeyEvent(int32_t routingId);

IPC::Message*
Msg_DispatchAfterKeyboardEvent(int32_t routingId);

IPC::Message*
Msg_RequestNativeKeyBindings(int32_t routingId);
IPC::Message*
Reply_RequestNativeKeyBindings(int32_t routingId);

IPC::Message*
Msg_SynthesizeNativeKeyEvent(int32_t routingId);

IPC::Message*
Msg_SynthesizeNativeMouseEvent(int32_t routingId);

IPC::Message*
Msg_SynthesizeNativeMouseMove(int32_t routingId);

IPC::Message*
Msg_SynthesizeNativeMouseScrollEvent(int32_t routingId);

IPC::Message*
Msg_SynthesizeNativeTouchPoint(int32_t routingId);

IPC::Message*
Msg_SynthesizeNativeTouchTap(int32_t routingId);

IPC::Message*
Msg_ClearNativeTouchSequence(int32_t routingId);

IPC::Message*
Msg_GetTabCount(int32_t routingId);
IPC::Message*
Reply_GetTabCount(int32_t routingId);

IPC::Message*
Msg_AccessKeyNotHandled(int32_t routingId);

IPC::Message*
Msg_NativeSynthesisResponse(int32_t routingId);

IPC::Message*
Msg_RemotePaintIsReady(int32_t routingId);

IPC::Message*
Msg_ForcePaintNoOp(int32_t routingId);

IPC::Message*
Msg_SetDimensions(int32_t routingId);

IPC::Message*
Msg_DispatchWheelEvent(int32_t routingId);
IPC::Message*
Reply_DispatchWheelEvent(int32_t routingId);

IPC::Message*
Msg_DispatchMouseEvent(int32_t routingId);
IPC::Message*
Reply_DispatchMouseEvent(int32_t routingId);

IPC::Message*
Msg_DispatchKeyboardEvent(int32_t routingId);
IPC::Message*
Reply_DispatchKeyboardEvent(int32_t routingId);

IPC::Message*
Msg_InvokeDragSession(int32_t routingId);

IPC::Message*
Msg_AudioChannelActivityNotification(int32_t routingId);

IPC::Message*
Msg_EnsureLayersConnected(int32_t routingId);
IPC::Message*
Reply_EnsureLayersConnected(int32_t routingId);

IPC::Message*
Msg_NotifySessionHistoryChange(int32_t routingId);

IPC::Message*
Msg_RequestCrossBrowserNavigation(int32_t routingId);

IPC::Message*
Msg_Show(int32_t routingId);

IPC::Message*
Msg_LoadURL(int32_t routingId);

IPC::Message*
Msg_UpdateDimensions(int32_t routingId);

IPC::Message*
Msg_SizeModeChanged(int32_t routingId);

IPC::Message*
Msg_Activate(int32_t routingId);

IPC::Message*
Msg_Deactivate(int32_t routingId);

IPC::Message*
Msg_ParentActivated(int32_t routingId);

IPC::Message*
Msg_SetKeyboardIndicators(int32_t routingId);

IPC::Message*
Msg_StopIMEStateManagement(int32_t routingId);

IPC::Message*
Msg_MenuKeyboardListenerInstalled(int32_t routingId);

IPC::Message*
Msg_MouseEvent(int32_t routingId);

IPC::Message*
Msg_RealMouseMoveEvent(int32_t routingId);

IPC::Message*
Msg_SynthMouseMoveEvent(int32_t routingId);

IPC::Message*
Msg_RealMouseButtonEvent(int32_t routingId);

IPC::Message*
Msg_RealKeyEvent(int32_t routingId);

IPC::Message*
Msg_MouseWheelEvent(int32_t routingId);

IPC::Message*
Msg_RealTouchEvent(int32_t routingId);

IPC::Message*
Msg_HandleTap(int32_t routingId);

IPC::Message*
Msg_RealTouchMoveEvent(int32_t routingId);

IPC::Message*
Msg_RealDragEvent(int32_t routingId);

IPC::Message*
Msg_PluginEvent(int32_t routingId);

IPC::Message*
Msg_KeyEvent(int32_t routingId);

IPC::Message*
Msg_CompositionEvent(int32_t routingId);

IPC::Message*
Msg_SelectionEvent(int32_t routingId);

IPC::Message*
Msg_PasteTransferable(int32_t routingId);

IPC::Message*
Msg_ActivateFrameEvent(int32_t routingId);

IPC::Message*
Msg_LoadRemoteScript(int32_t routingId);

IPC::Message*
Msg_Destroy(int32_t routingId);

IPC::Message*
Msg_SetDocShellIsActive(int32_t routingId);

IPC::Message*
Msg_SuppressDisplayport(int32_t routingId);

IPC::Message*
Msg_NavigateByKey(int32_t routingId);

IPC::Message*
Msg_RequestNotifyAfterRemotePaint(int32_t routingId);

IPC::Message*
Msg_UIResolutionChanged(int32_t routingId);

IPC::Message*
Msg_ThemeChanged(int32_t routingId);

IPC::Message*
Msg_SwappedWithOtherRemoteLoader(int32_t routingId);

IPC::Message*
Msg_HandleAccessKey(int32_t routingId);

IPC::Message*
Msg_AudioChannelChangeNotification(int32_t routingId);

IPC::Message*
Msg_SetUseGlobalHistory(int32_t routingId);

IPC::Message*
Msg_HandledWindowedPluginKeyEvent(int32_t routingId);

IPC::Message*
Msg_Print(int32_t routingId);

IPC::Message*
Msg_UpdateNativeWindowHandle(int32_t routingId);

IPC::Message*
Msg_NotifyAttachGroupedSessionHistory(int32_t routingId);

IPC::Message*
Msg_NotifyPartialSessionHistoryActive(int32_t routingId);

IPC::Message*
Msg_NotifyPartialSessionHistoryDeactive(int32_t routingId);

IPC::Message*
Msg_SetFreshProcess(int32_t routingId);



} // namespace PBrowser
} // namespace dom
} // namespace mozilla

#endif // ifndef PBrowser_h
