//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PScreenManagerChild_h
#define PScreenManagerChild_h

#include "mozilla/dom/PScreenManager.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/GfxMessageUtils.h"
#include "mozilla/dom/ipc/IdType.h"
#include "nsRect.h"

namespace mozilla {
namespace dom {
class PBrowserChild;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {


class PScreenManagerChild :
    public mozilla::ipc::IProtocol
{
    friend class mozilla::dom::PContentChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::dom::ScreenDetails ScreenDetails;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::dom::TabId TabId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::dom::PBrowserChild PBrowserChild;
    typedef mozilla::dom::PBrowserParent PBrowserParent;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef mozilla::dom::PContentParent PContentParent;

    typedef PScreenManager::State State;

    virtual bool
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    MOZ_IMPLICIT PScreenManagerChild();

    virtual ~PScreenManagerChild();

    PContentChild*
    Manager() const;

    PScreenManager::State
    state();

    bool
    SendRefresh(
            uint32_t* numberOfScreens,
            float* systemDefaultScale,
            bool* success);

    bool
    SendScreenRefresh(
            const uint32_t& aId,
            ScreenDetails* screen,
            bool* success);

    bool
    SendGetPrimaryScreen(
            ScreenDetails* screen,
            bool* success);

    bool
    SendScreenForRect(
            const int32_t& aLeft,
            const int32_t& aTop,
            const int32_t& aWidth,
            const int32_t& aHeight,
            ScreenDetails* screen,
            bool* success);

    bool
    SendScreenForBrowser(
            const TabId& aTabId,
            ScreenDetails* screen,
            bool* success);

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const ScreenDetails& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            ScreenDetails* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PScreenManagerChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PScreenManagerChild** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    State mState;
};


} // namespace dom
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class ScreenManagerChild :
    public PScreenManagerChild
{
    MOZ_IMPLICIT ScreenManagerChild();
    virtual ~ScreenManagerChild();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
MOZ_IMPLICIT ScreenManagerChild::ScreenManagerChild()
{
    MOZ_COUNT_CTOR(ScreenManagerChild);
}

MOZ_IMPLICIT ScreenManagerChild::~ScreenManagerChild()
{
    MOZ_COUNT_DTOR(ScreenManagerChild);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PScreenManagerChild_h
