//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PServiceWorkerManagerParent_h
#define PServiceWorkerManagerParent_h

#include "mozilla/dom/PServiceWorkerManager.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/ipc/BackgroundUtils.h"

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {


class PServiceWorkerManagerParent :
    public mozilla::ipc::IProtocol
{
    friend class mozilla::ipc::PBackgroundParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ContentPrincipalInfo ContentPrincipalInfo;
    typedef mozilla::ipc::ContentPrincipalInfoOriginNoSuffix ContentPrincipalInfoOriginNoSuffix;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::ExpandedPrincipalInfo ExpandedPrincipalInfo;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::ipc::NullPrincipalInfo NullPrincipalInfo;
    typedef mozilla::ipc::OptionalPrincipalInfo OptionalPrincipalInfo;
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef mozilla::PrincipalOriginAttributes PrincipalOriginAttributes;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::dom::ServiceWorkerRegistrationData ServiceWorkerRegistrationData;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::SystemPrincipalInfo SystemPrincipalInfo;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::void_t void_t;
    typedef mozilla::ipc::PBackgroundParent PBackgroundParent;
    typedef mozilla::ipc::PBackgroundChild PBackgroundChild;

    typedef PServiceWorkerManager::State State;

    virtual bool
    RecvRegister(const ServiceWorkerRegistrationData& data) = 0;
    virtual bool
    RecvUnregister(
            const PrincipalInfo& principalInfo,
            const nsString& scope) = 0;
    virtual bool
    RecvPropagateSoftUpdate(
            const PrincipalOriginAttributes& originAttributes,
            const nsString& scope) = 0;
    virtual bool
    RecvPropagateUnregister(
            const PrincipalInfo& principalInfo,
            const nsString& scope) = 0;
    virtual bool
    RecvPropagateRemove(const nsCString& host) = 0;
    virtual bool
    RecvPropagateRemoveAll() = 0;
    virtual bool
    RecvShutdown() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    MOZ_IMPLICIT PServiceWorkerManagerParent();

    virtual ~PServiceWorkerManagerParent();

    PBackgroundParent*
    Manager() const;

    PServiceWorkerManager::State
    state();

    MOZ_MUST_USE bool
    SendNotifyRegister(const ServiceWorkerRegistrationData& data);

    MOZ_MUST_USE bool
    SendNotifySoftUpdate(
            const PrincipalOriginAttributes& originAttributes,
            const nsString& scope);

    MOZ_MUST_USE bool
    SendNotifyUnregister(
            const PrincipalInfo& principalInfo,
            const nsString& scope);

    MOZ_MUST_USE bool
    SendNotifyRemove(const nsCString& host);

    MOZ_MUST_USE bool
    SendNotifyRemoveAll();

    MOZ_MUST_USE static bool
    Send__delete__(PServiceWorkerManagerParent* actor);

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const SystemPrincipalInfo& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            SystemPrincipalInfo* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const nsTArray<PrincipalInfo>& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            nsTArray<PrincipalInfo>* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const ExpandedPrincipalInfo& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            ExpandedPrincipalInfo* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PrincipalInfo& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            PrincipalInfo* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const ContentPrincipalInfoOriginNoSuffix& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            ContentPrincipalInfoOriginNoSuffix* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PServiceWorkerManagerParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PServiceWorkerManagerParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            const ContentPrincipalInfo& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            ContentPrincipalInfo* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const NullPrincipalInfo& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            NullPrincipalInfo* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const ServiceWorkerRegistrationData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            ServiceWorkerRegistrationData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    State mState;
};


} // namespace dom
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class ServiceWorkerManagerParent :
    public PServiceWorkerManagerParent
{
    virtual bool
    RecvRegister(const ServiceWorkerRegistrationData& data);

    virtual bool
    RecvUnregister(
            const PrincipalInfo& principalInfo,
            const nsString& scope);

    virtual bool
    RecvPropagateSoftUpdate(
            const PrincipalOriginAttributes& originAttributes,
            const nsString& scope);

    virtual bool
    RecvPropagateUnregister(
            const PrincipalInfo& principalInfo,
            const nsString& scope);

    virtual bool
    RecvPropagateRemove(const nsCString& host);

    virtual bool
    RecvPropagateRemoveAll();

    virtual bool
    RecvShutdown();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT ServiceWorkerManagerParent();
    virtual ~ServiceWorkerManagerParent();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
bool
ServiceWorkerManagerParent::RecvRegister(const ServiceWorkerRegistrationData& data)
{
    return false;
}

bool
ServiceWorkerManagerParent::RecvUnregister(
        const PrincipalInfo& principalInfo,
        const nsString& scope)
{
    return false;
}

bool
ServiceWorkerManagerParent::RecvPropagateSoftUpdate(
        const PrincipalOriginAttributes& originAttributes,
        const nsString& scope)
{
    return false;
}

bool
ServiceWorkerManagerParent::RecvPropagateUnregister(
        const PrincipalInfo& principalInfo,
        const nsString& scope)
{
    return false;
}

bool
ServiceWorkerManagerParent::RecvPropagateRemove(const nsCString& host)
{
    return false;
}

bool
ServiceWorkerManagerParent::RecvPropagateRemoveAll()
{
    return false;
}

bool
ServiceWorkerManagerParent::RecvShutdown()
{
    return false;
}

void
ServiceWorkerManagerParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT ServiceWorkerManagerParent::ServiceWorkerManagerParent()
{
    MOZ_COUNT_CTOR(ServiceWorkerManagerParent);
}

MOZ_IMPLICIT ServiceWorkerManagerParent::~ServiceWorkerManagerParent()
{
    MOZ_COUNT_DTOR(ServiceWorkerManagerParent);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PServiceWorkerManagerParent_h
