//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGPUChild_h
#define PGPUChild_h

#include "mozilla/gfx/PGPU.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "Units.h"
#include "base/process.h"
#include "mozilla/TelemetryComms.h"
#include "mozilla/TimeStamp.h"
#include "mozilla/gfx/2D.h"

namespace mozilla {
namespace layers {
class PCompositorBridgeChild;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class PCompositorBridgeParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PImageBridgeChild;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class PImageBridgeParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace gfx {
class PVRManagerChild;
} // namespace gfx
} // namespace mozilla
namespace mozilla {
namespace gfx {
class PVRManagerParent;
} // namespace gfx
} // namespace mozilla

namespace mozilla {
namespace gfx {
class PVsyncBridgeChild;
} // namespace gfx
} // namespace mozilla
namespace mozilla {
namespace gfx {
class PVsyncBridgeParent;
} // namespace gfx
} // namespace mozilla

namespace mozilla {
namespace dom {
class PVideoDecoderManagerChild;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PVideoDecoderManagerParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace gfx {


class PGPUChild :
    public mozilla::ipc::IToplevelProtocol
{
protected:
    typedef mozilla::Telemetry::Accumulation Accumulation;
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::gfx::BackendType BackendType;
    typedef mozilla::CSSToLayoutDeviceScale CSSToLayoutDeviceScale;
    typedef mozilla::gfx::ContentDeviceData ContentDeviceData;
    typedef mozilla::gfx::D3D11DeviceStatus D3D11DeviceStatus;
    typedef mozilla::gfx::DevicePrefs DevicePrefs;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::gfx::FeatureChange FeatureChange;
    typedef mozilla::gfx::FeatureFailure FeatureFailure;
    typedef mozilla::gfx::FeatureStatus FeatureStatus;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gfx::GPUDeviceData GPUDeviceData;
    typedef mozilla::gfx::GPUDeviceStatus GPUDeviceStatus;
    typedef mozilla::gfx::GfxPrefSetting GfxPrefSetting;
    typedef mozilla::gfx::GfxPrefValue GfxPrefValue;
    typedef mozilla::gfx::GfxVarUpdate GfxVarUpdate;
    typedef mozilla::gfx::GfxVarValue GfxVarValue;
    typedef mozilla::gfx::IntSize IntSize;
    typedef mozilla::Telemetry::KeyedAccumulation KeyedAccumulation;
    typedef mozilla::gfx::LayerTreeIdMapping LayerTreeIdMapping;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::TimeDuration TimeDuration;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::null_t null_t;
    typedef mozilla::layers::PCompositorBridgeChild PCompositorBridgeChild;
    typedef mozilla::layers::PCompositorBridgeParent PCompositorBridgeParent;
    typedef mozilla::layers::PImageBridgeChild PImageBridgeChild;
    typedef mozilla::layers::PImageBridgeParent PImageBridgeParent;
    typedef mozilla::gfx::PVRManagerChild PVRManagerChild;
    typedef mozilla::gfx::PVRManagerParent PVRManagerParent;
    typedef mozilla::gfx::PVsyncBridgeChild PVsyncBridgeChild;
    typedef mozilla::gfx::PVsyncBridgeParent PVsyncBridgeParent;
    typedef mozilla::dom::PVideoDecoderManagerChild PVideoDecoderManagerChild;
    typedef mozilla::dom::PVideoDecoderManagerParent PVideoDecoderManagerParent;

    typedef PGPU::State State;

    virtual bool
    RecvInitComplete(const GPUDeviceData& data) = 0;
    virtual bool
    RecvReportCheckerboard(
            const uint32_t& severity,
            const nsCString& log) = 0;
    virtual bool
    RecvGraphicsError(const nsCString& aError) = 0;
    virtual bool
    RecvInitCrashReporter(Shmem&& shmem) = 0;
    virtual bool
    RecvNotifyUiObservers(const nsCString& aTopic) = 0;
    virtual bool
    RecvAccumulateChildHistogram(nsTArray<Accumulation>&& accumulations) = 0;
    virtual bool
    RecvAccumulateChildKeyedHistogram(nsTArray<KeyedAccumulation>&& accumulations) = 0;
    virtual bool
    RecvNotifyDeviceReset() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    virtual void
    ProcessingError(
            Result aCode,
            const char* aReason);
    virtual bool
    ShouldContinueFromReplyTimeout();
    virtual void
    EnteredCxxStack();
    virtual void
    ExitedCxxStack();
    virtual void
    EnteredCall();
    virtual void
    ExitedCall();

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    MOZ_IMPLICIT PGPUChild();

    virtual ~PGPUChild();

    PGPU::State
    state();

    bool
    SendInit(
            const nsTArray<GfxPrefSetting>& prefs,
            const nsTArray<GfxVarUpdate>& vars,
            const DevicePrefs& devicePrefs);

    bool
    SendInitVsyncBridge(const Endpoint<mozilla::gfx::PVsyncBridgeParent>& endpoint);

    bool
    SendInitImageBridge(const Endpoint<mozilla::layers::PImageBridgeParent>& endpoint);

    bool
    SendInitVRManager(const Endpoint<mozilla::gfx::PVRManagerParent>& endpoint);

    bool
    SendUpdatePref(const GfxPrefSetting& pref);

    bool
    SendUpdateVar(const GfxVarUpdate& var);

    bool
    SendNewWidgetCompositor(
            const Endpoint<mozilla::layers::PCompositorBridgeParent>& endpoint,
            const CSSToLayoutDeviceScale& scale,
            const TimeDuration& vsyncRate,
            const bool& useExternalSurface,
            const IntSize& surfaceSize);

    bool
    SendNewContentCompositorBridge(const Endpoint<mozilla::layers::PCompositorBridgeParent>& endpoint);

    bool
    SendNewContentImageBridge(const Endpoint<mozilla::layers::PImageBridgeParent>& endpoint);

    bool
    SendNewContentVRManager(const Endpoint<mozilla::gfx::PVRManagerParent>& endpoint);

    bool
    SendNewContentVideoDecoderManager(const Endpoint<mozilla::dom::PVideoDecoderManagerParent>& endpoint);

    bool
    SendAddLayerTreeIdMapping(const nsTArray<LayerTreeIdMapping>& mapping);

    bool
    SendRemoveLayerTreeIdMapping(const LayerTreeIdMapping& mapping);

    bool
    SendGetDeviceStatus(GPUDeviceData* status);

    bool
    SendNotifyGpuObservers(const nsCString& aTopic);

    virtual MessageChannel*
    GetIPCChannel();
    virtual const MessageChannel*
    GetIPCChannel() const;
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

    void
    OnChannelClose();

    void
    OnChannelError();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    virtual void
    DeallocPGPUChild();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const nsTArray<LayerTreeIdMapping>& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            nsTArray<LayerTreeIdMapping>* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const DevicePrefs& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            DevicePrefs* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const GfxPrefSetting& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            GfxPrefSetting* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            Shmem& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            Shmem* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const GPUDeviceData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            GPUDeviceData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const nsTArray<GfxVarUpdate>& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            nsTArray<GfxVarUpdate>* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const GfxVarUpdate& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            GfxVarUpdate* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const nsTArray<GfxPrefSetting>& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            nsTArray<GfxPrefSetting>* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const GPUDeviceStatus& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            GPUDeviceStatus* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const GfxVarValue& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            GfxVarValue* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const FeatureFailure& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            FeatureFailure* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const FeatureChange& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            FeatureChange* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const LayerTreeIdMapping& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            LayerTreeIdMapping* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const D3D11DeviceStatus& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            D3D11DeviceStatus* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const GfxPrefValue& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            GfxPrefValue* v__,
            const Message* msg__,
            PickleIterator* iter__);

    Channel mChannel;
    State mState;
};


} // namespace gfx
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gfx {
class GPUChild :
    public PGPUChild
{
    virtual bool
    RecvInitComplete(const GPUDeviceData& data);

    virtual bool
    RecvReportCheckerboard(
            const uint32_t& severity,
            const nsCString& log);

    virtual bool
    RecvGraphicsError(const nsCString& aError);

    virtual bool
    RecvInitCrashReporter(Shmem&& shmem);

    virtual bool
    RecvNotifyUiObservers(const nsCString& aTopic);

    virtual bool
    RecvAccumulateChildHistogram(nsTArray<Accumulation>&& accumulations);

    virtual bool
    RecvAccumulateChildKeyedHistogram(nsTArray<KeyedAccumulation>&& accumulations);

    virtual bool
    RecvNotifyDeviceReset();

    MOZ_IMPLICIT GPUChild();
    virtual ~GPUChild();
};
} // namespace gfx
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gfx {
bool
GPUChild::RecvInitComplete(const GPUDeviceData& data)
{
    return false;
}

bool
GPUChild::RecvReportCheckerboard(
        const uint32_t& severity,
        const nsCString& log)
{
    return false;
}

bool
GPUChild::RecvGraphicsError(const nsCString& aError)
{
    return false;
}

bool
GPUChild::RecvInitCrashReporter(Shmem&& shmem)
{
    return false;
}

bool
GPUChild::RecvNotifyUiObservers(const nsCString& aTopic)
{
    return false;
}

bool
GPUChild::RecvAccumulateChildHistogram(nsTArray<Accumulation>&& accumulations)
{
    return false;
}

bool
GPUChild::RecvAccumulateChildKeyedHistogram(nsTArray<KeyedAccumulation>&& accumulations)
{
    return false;
}

bool
GPUChild::RecvNotifyDeviceReset()
{
    return false;
}

MOZ_IMPLICIT GPUChild::GPUChild()
{
    MOZ_COUNT_CTOR(GPUChild);
}

MOZ_IMPLICIT GPUChild::~GPUChild()
{
    MOZ_COUNT_DTOR(GPUChild);
}

} // namespace gfx
} // namespace mozilla
#endif // if 0

#endif // ifndef PGPUChild_h
