//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPDecryptorParent_h
#define PGMPDecryptorParent_h

#include "mozilla/gmp/PGMPDecryptor.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "gmp-decryption.h"
#include "gmp-errors.h"

namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla
namespace mozilla {
namespace gmp {
class PGMPContentChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPContentParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class PGMPDecryptorParent :
    public mozilla::ipc::IProtocol
{
    friend class mozilla::gmp::PGMPContentParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gmp::GMPAudioCodecData GMPAudioCodecData;
    typedef mozilla::gmp::GMPAudioDecodedSampleData GMPAudioDecodedSampleData;
    typedef mozilla::gmp::GMPAudioEncodedSampleData GMPAudioEncodedSampleData;
    typedef mozilla::gmp::GMPDecryptionData GMPDecryptionData;
    typedef mozilla::gmp::GMPKeyInformation GMPKeyInformation;
    typedef mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::gmp::PGMPContentParent PGMPContentParent;
    typedef mozilla::gmp::PGMPContentChild PGMPContentChild;

    typedef PGMPDecryptor::State State;

    virtual bool
    Recv__delete__();
    virtual bool
    RecvSetDecryptorId(const uint32_t& aId) = 0;
    virtual bool
    RecvSetSessionId(
            const uint32_t& aCreateSessionToken,
            const nsCString& aSessionId) = 0;
    virtual bool
    RecvResolveLoadSessionPromise(
            const uint32_t& aPromiseId,
            const bool& aSuccess) = 0;
    virtual bool
    RecvResolvePromise(const uint32_t& aPromiseId) = 0;
    virtual bool
    RecvRejectPromise(
            const uint32_t& aPromiseId,
            const GMPDOMException& aDOMExceptionCode,
            const nsCString& aMessage) = 0;
    virtual bool
    RecvSessionMessage(
            const nsCString& aSessionId,
            const GMPSessionMessageType& aMessageType,
            nsTArray<uint8_t>&& aMessage) = 0;
    virtual bool
    RecvExpirationChange(
            const nsCString& aSessionId,
            const double& aExpiryTime) = 0;
    virtual bool
    RecvSessionClosed(const nsCString& aSessionId) = 0;
    virtual bool
    RecvSessionError(
            const nsCString& aSessionId,
            const GMPDOMException& aDOMExceptionCode,
            const uint32_t& aSystemCode,
            const nsCString& aMessage) = 0;
    virtual bool
    RecvDecrypted(
            const uint32_t& aId,
            const GMPErr& aResult,
            nsTArray<uint8_t>&& aBuffer) = 0;
    virtual bool
    RecvShutdown() = 0;
    virtual bool
    RecvBatchedKeyStatusChanged(
            const nsCString& aSessionId,
            nsTArray<GMPKeyInformation>&& aKeyInfos) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    MOZ_IMPLICIT PGMPDecryptorParent();

    virtual ~PGMPDecryptorParent();

    PGMPContentParent*
    Manager() const;

    PGMPDecryptor::State
    state();

    MOZ_MUST_USE bool
    SendInit(
            const bool& aDistinctiveIdentifierRequired,
            const bool& aPersistentStateRequired);

    MOZ_MUST_USE bool
    SendCreateSession(
            const uint32_t& aCreateSessionToken,
            const uint32_t& aPromiseId,
            const nsCString& aInitDataType,
            const nsTArray<uint8_t>& aInitData,
            const GMPSessionType& aSessionType);

    MOZ_MUST_USE bool
    SendLoadSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId);

    MOZ_MUST_USE bool
    SendUpdateSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId,
            const nsTArray<uint8_t>& aResponse);

    MOZ_MUST_USE bool
    SendCloseSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId);

    MOZ_MUST_USE bool
    SendRemoveSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId);

    MOZ_MUST_USE bool
    SendSetServerCertificate(
            const uint32_t& aPromiseId,
            const nsTArray<uint8_t>& aServerCert);

    MOZ_MUST_USE bool
    SendDecrypt(
            const uint32_t& aId,
            const nsTArray<uint8_t>& aBuffer,
            const GMPDecryptionData& aMetadata);

    MOZ_MUST_USE bool
    SendDecryptingComplete();

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const GMPDecryptionData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            GMPDecryptionData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const nsTArray<GMPKeyInformation>& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            nsTArray<GMPKeyInformation>* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const GMPKeyInformation& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            GMPKeyInformation* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PGMPDecryptorParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PGMPDecryptorParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    State mState;
};


} // namespace gmp
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gmp {
class GMPDecryptorParent :
    public PGMPDecryptorParent
{
    virtual bool
    RecvSetDecryptorId(const uint32_t& aId);

    virtual bool
    RecvSetSessionId(
            const uint32_t& aCreateSessionToken,
            const nsCString& aSessionId);

    virtual bool
    RecvResolveLoadSessionPromise(
            const uint32_t& aPromiseId,
            const bool& aSuccess);

    virtual bool
    RecvResolvePromise(const uint32_t& aPromiseId);

    virtual bool
    RecvRejectPromise(
            const uint32_t& aPromiseId,
            const GMPDOMException& aDOMExceptionCode,
            const nsCString& aMessage);

    virtual bool
    RecvSessionMessage(
            const nsCString& aSessionId,
            const GMPSessionMessageType& aMessageType,
            nsTArray<uint8_t>&& aMessage);

    virtual bool
    RecvExpirationChange(
            const nsCString& aSessionId,
            const double& aExpiryTime);

    virtual bool
    RecvSessionClosed(const nsCString& aSessionId);

    virtual bool
    RecvSessionError(
            const nsCString& aSessionId,
            const GMPDOMException& aDOMExceptionCode,
            const uint32_t& aSystemCode,
            const nsCString& aMessage);

    virtual bool
    RecvDecrypted(
            const uint32_t& aId,
            const GMPErr& aResult,
            nsTArray<uint8_t>&& aBuffer);

    virtual bool
    RecvShutdown();

    virtual bool
    RecvBatchedKeyStatusChanged(
            const nsCString& aSessionId,
            nsTArray<GMPKeyInformation>&& aKeyInfos);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT GMPDecryptorParent();
    virtual ~GMPDecryptorParent();
};
} // namespace gmp
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gmp {
bool
GMPDecryptorParent::RecvSetDecryptorId(const uint32_t& aId)
{
    return false;
}

bool
GMPDecryptorParent::RecvSetSessionId(
        const uint32_t& aCreateSessionToken,
        const nsCString& aSessionId)
{
    return false;
}

bool
GMPDecryptorParent::RecvResolveLoadSessionPromise(
        const uint32_t& aPromiseId,
        const bool& aSuccess)
{
    return false;
}

bool
GMPDecryptorParent::RecvResolvePromise(const uint32_t& aPromiseId)
{
    return false;
}

bool
GMPDecryptorParent::RecvRejectPromise(
        const uint32_t& aPromiseId,
        const GMPDOMException& aDOMExceptionCode,
        const nsCString& aMessage)
{
    return false;
}

bool
GMPDecryptorParent::RecvSessionMessage(
        const nsCString& aSessionId,
        const GMPSessionMessageType& aMessageType,
        nsTArray<uint8_t>&& aMessage)
{
    return false;
}

bool
GMPDecryptorParent::RecvExpirationChange(
        const nsCString& aSessionId,
        const double& aExpiryTime)
{
    return false;
}

bool
GMPDecryptorParent::RecvSessionClosed(const nsCString& aSessionId)
{
    return false;
}

bool
GMPDecryptorParent::RecvSessionError(
        const nsCString& aSessionId,
        const GMPDOMException& aDOMExceptionCode,
        const uint32_t& aSystemCode,
        const nsCString& aMessage)
{
    return false;
}

bool
GMPDecryptorParent::RecvDecrypted(
        const uint32_t& aId,
        const GMPErr& aResult,
        nsTArray<uint8_t>&& aBuffer)
{
    return false;
}

bool
GMPDecryptorParent::RecvShutdown()
{
    return false;
}

bool
GMPDecryptorParent::RecvBatchedKeyStatusChanged(
        const nsCString& aSessionId,
        nsTArray<GMPKeyInformation>&& aKeyInfos)
{
    return false;
}

void
GMPDecryptorParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT GMPDecryptorParent::GMPDecryptorParent()
{
    MOZ_COUNT_CTOR(GMPDecryptorParent);
}

MOZ_IMPLICIT GMPDecryptorParent::~GMPDecryptorParent()
{
    MOZ_COUNT_DTOR(GMPDecryptorParent);
}

} // namespace gmp
} // namespace mozilla
#endif // if 0

#endif // ifndef PGMPDecryptorParent_h
