//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PHalChild_h
#define PHalChild_h

#include "mozilla/hal_sandbox/PHal.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/GfxMessageUtils.h"
#include "mozilla/HalSensor.h"
#include "mozilla/HalTypes.h"
#include "mozilla/dom/ScreenOrientation.h"
#include "nsRect.h"
#include "prtime.h"

namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBrowserChild;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace hal_sandbox {


class PHalChild :
    public mozilla::ipc::IProtocol
{
    friend class mozilla::dom::PContentChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::hal::BatteryInformation BatteryInformation;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef base::ProcessId ProcessId;
    typedef mozilla::hal::ProcessPriority ProcessPriority;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::hal::ScreenConfiguration ScreenConfiguration;
    typedef mozilla::dom::ScreenOrientationInternal ScreenOrientationInternal;
    typedef mozilla::hal::SensorAccuracyType SensorAccuracyType;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::SystemTimezoneChangeInformation SystemTimezoneChangeInformation;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::hal::WakeLockControl WakeLockControl;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef mozilla::dom::PBrowserChild PBrowserChild;
    typedef mozilla::dom::PBrowserParent PBrowserParent;

    typedef PHal::State State;

    virtual bool
    RecvNotifyBatteryChange(const BatteryInformation& aBatteryInfo) = 0;
    virtual bool
    RecvNotifyNetworkChange(const NetworkInformation& aNetworkInfo) = 0;
    virtual bool
    RecvNotifyWakeLockChange(const WakeLockInformation& aWakeLockInfo) = 0;
    virtual bool
    RecvNotifyScreenConfigurationChange(const ScreenConfiguration& aScreenOrientation) = 0;
    virtual bool
    RecvNotifySystemClockChange(const int64_t& aClockDeltaMS) = 0;
    virtual bool
    RecvNotifySystemTimezoneChange(const SystemTimezoneChangeInformation& aSystemTimezoneChangeInfo) = 0;
    virtual bool
    RecvNotifySensorChange(const SensorData& aSensorData) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    MOZ_IMPLICIT PHalChild();

    virtual ~PHalChild();

    PContentChild*
    Manager() const;

    PHal::State
    state();

    bool
    SendVibrate(
            const nsTArray<uint32_t>& pattern,
            const nsTArray<uint64_t>& id,
            PBrowserChild* browser);

    bool
    SendCancelVibrate(
            const nsTArray<uint64_t>& id,
            PBrowserChild* browser);

    bool
    SendEnableBatteryNotifications();

    bool
    SendDisableBatteryNotifications();

    bool
    SendGetCurrentBatteryInformation(BatteryInformation* aBatteryInfo);

    bool
    SendEnableNetworkNotifications();

    bool
    SendDisableNetworkNotifications();

    bool
    SendGetCurrentNetworkInformation(NetworkInformation* aNetworkInfo);

    bool
    SendGetScreenEnabled(bool* enabled);

    bool
    SendSetScreenEnabled(const bool& aEnabled);

    bool
    SendGetKeyLightEnabled(bool* enabled);

    bool
    SendSetKeyLightEnabled(const bool& aEnabled);

    bool
    SendGetCpuSleepAllowed(bool* allowed);

    bool
    SendSetCpuSleepAllowed(const bool& aAllowed);

    bool
    SendGetScreenBrightness(double* brightness);

    bool
    SendSetScreenBrightness(const double& aBrightness);

    bool
    SendAdjustSystemClock(const int64_t& aDeltaMilliseconds);

    bool
    SendSetTimezone(const nsCString& aTimezoneSpec);

    bool
    SendGetTimezone(nsCString* aTimezoneSpec);

    bool
    SendGetTimezoneOffset(int32_t* aTimezoneOffset);

    bool
    SendEnableSystemClockChangeNotifications();

    bool
    SendDisableSystemClockChangeNotifications();

    bool
    SendEnableSystemTimezoneChangeNotifications();

    bool
    SendDisableSystemTimezoneChangeNotifications();

    bool
    SendModifyWakeLock(
            const nsString& aTopic,
            const WakeLockControl& aLockAdjust,
            const WakeLockControl& aHiddenAdjust,
            const uint64_t& aProcessID);

    bool
    SendEnableWakeLockNotifications();

    bool
    SendDisableWakeLockNotifications();

    bool
    SendGetWakeLockInfo(
            const nsString& aTopic,
            WakeLockInformation* aWakeLockInfo);

    bool
    SendEnableScreenConfigurationNotifications();

    bool
    SendDisableScreenConfigurationNotifications();

    bool
    SendGetCurrentScreenConfiguration(ScreenConfiguration* aScreenConfiguration);

    bool
    SendLockScreenOrientation(
            const ScreenOrientationInternal& aOrientation,
            bool* allowed);

    bool
    SendUnlockScreenOrientation();

    bool
    SendFactoryReset(const nsString& aReason);

    bool
    SendEnableSensorNotifications(const SensorType& aSensor);

    bool
    SendDisableSensorNotifications(const SensorType& aSensor);

    static bool
    Send__delete__(PHalChild* actor);

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const PBrowserChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PBrowserChild** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    void
    Write(
            const ScreenConfiguration& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            ScreenConfiguration* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const BatteryInformation& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            BatteryInformation* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const WakeLockInformation& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            WakeLockInformation* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const NetworkInformation& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            NetworkInformation* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const SystemTimezoneChangeInformation& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            SystemTimezoneChangeInformation* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const SensorData& v__,
            Message* msg__);

    MOZ_MUST_USE bool
    Read(
            SensorData* v__,
            const Message* msg__,
            PickleIterator* iter__);

    void
    Write(
            const PHalChild* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PHalChild** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    State mState;
};


} // namespace hal_sandbox
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace hal_sandbox {
class HalChild :
    public PHalChild
{
    virtual bool
    RecvNotifyBatteryChange(const BatteryInformation& aBatteryInfo);

    virtual bool
    RecvNotifyNetworkChange(const NetworkInformation& aNetworkInfo);

    virtual bool
    RecvNotifyWakeLockChange(const WakeLockInformation& aWakeLockInfo);

    virtual bool
    RecvNotifyScreenConfigurationChange(const ScreenConfiguration& aScreenOrientation);

    virtual bool
    RecvNotifySystemClockChange(const int64_t& aClockDeltaMS);

    virtual bool
    RecvNotifySystemTimezoneChange(const SystemTimezoneChangeInformation& aSystemTimezoneChangeInfo);

    virtual bool
    RecvNotifySensorChange(const SensorData& aSensorData);

    MOZ_IMPLICIT HalChild();
    virtual ~HalChild();
};
} // namespace hal_sandbox
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace hal_sandbox {
bool
HalChild::RecvNotifyBatteryChange(const BatteryInformation& aBatteryInfo)
{
    return false;
}

bool
HalChild::RecvNotifyNetworkChange(const NetworkInformation& aNetworkInfo)
{
    return false;
}

bool
HalChild::RecvNotifyWakeLockChange(const WakeLockInformation& aWakeLockInfo)
{
    return false;
}

bool
HalChild::RecvNotifyScreenConfigurationChange(const ScreenConfiguration& aScreenOrientation)
{
    return false;
}

bool
HalChild::RecvNotifySystemClockChange(const int64_t& aClockDeltaMS)
{
    return false;
}

bool
HalChild::RecvNotifySystemTimezoneChange(const SystemTimezoneChangeInformation& aSystemTimezoneChangeInfo)
{
    return false;
}

bool
HalChild::RecvNotifySensorChange(const SensorData& aSensorData)
{
    return false;
}

MOZ_IMPLICIT HalChild::HalChild()
{
    MOZ_COUNT_CTOR(HalChild);
}

MOZ_IMPLICIT HalChild::~HalChild()
{
    MOZ_COUNT_DTOR(HalChild);
}

} // namespace hal_sandbox
} // namespace mozilla
#endif // if 0

#endif // ifndef PHalChild_h
