//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef InputStreamParams_h
#define InputStreamParams_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "ipc/IPCMessageUtils.h"
#include "mozilla/ipc/ProtocolTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct StringInputStreamParams|
//
namespace mozilla {
namespace ipc {
class StringInputStreamParams final
{
private:

public:
    MOZ_IMPLICIT StringInputStreamParams();

    MOZ_IMPLICIT StringInputStreamParams(const nsCString& _data)
    {
        Init();
        Assign(_data);
    }

    MOZ_IMPLICIT StringInputStreamParams(const StringInputStreamParams& _o)
    {
        Init();
        Assign((_o).data());
    }

    ~StringInputStreamParams();

    void
    operator=(const StringInputStreamParams& _o)
    {
        Assign((_o).data());
    }

    bool
    operator==(const StringInputStreamParams& _o) const;

    nsCString&
    data()
    {
        return data_;
    }
    const nsCString&
    data() const
    {
        return data_;
    }

private:
    void
    Init();

    void
    Assign(const nsCString& _data);

    nsCString data_;
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileInputStreamParams|
//
namespace mozilla {
namespace ipc {
class FileInputStreamParams final
{
private:

public:
    MOZ_IMPLICIT FileInputStreamParams();

    MOZ_IMPLICIT FileInputStreamParams(
            const uint32_t& _fileDescriptorIndex,
            const int32_t& _behaviorFlags,
            const int32_t& _ioFlags)
    {
        Init();
        Assign(_fileDescriptorIndex, _behaviorFlags, _ioFlags);
    }

    MOZ_IMPLICIT FileInputStreamParams(const FileInputStreamParams& _o)
    {
        Init();
        Assign((_o).fileDescriptorIndex(), (_o).behaviorFlags(), (_o).ioFlags());
    }

    ~FileInputStreamParams();

    void
    operator=(const FileInputStreamParams& _o)
    {
        Assign((_o).fileDescriptorIndex(), (_o).behaviorFlags(), (_o).ioFlags());
    }

    bool
    operator==(const FileInputStreamParams& _o) const;

    uint32_t&
    fileDescriptorIndex()
    {
        return fileDescriptorIndex_;
    }
    const uint32_t&
    fileDescriptorIndex() const
    {
        return fileDescriptorIndex_;
    }

    int32_t&
    behaviorFlags()
    {
        return behaviorFlags_;
    }
    const int32_t&
    behaviorFlags() const
    {
        return behaviorFlags_;
    }

    int32_t&
    ioFlags()
    {
        return ioFlags_;
    }
    const int32_t&
    ioFlags() const
    {
        return ioFlags_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _fileDescriptorIndex,
            const int32_t& _behaviorFlags,
            const int32_t& _ioFlags);

    uint32_t fileDescriptorIndex_;
    int32_t behaviorFlags_;
    int32_t ioFlags_;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class FileInputStreamParams;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct PartialFileInputStreamParams|
//
namespace mozilla {
namespace ipc {
class PartialFileInputStreamParams final
{
private:
    typedef mozilla::ipc::FileInputStreamParams FileInputStreamParams;

public:
    MOZ_IMPLICIT PartialFileInputStreamParams();

    MOZ_IMPLICIT PartialFileInputStreamParams(
            const FileInputStreamParams& _fileStreamParams,
            const uint64_t& _begin,
            const uint64_t& _length)
    {
        Init();
        Assign(_fileStreamParams, _begin, _length);
    }

    MOZ_IMPLICIT PartialFileInputStreamParams(const PartialFileInputStreamParams& _o)
    {
        Init();
        Assign((_o).fileStreamParams(), (_o).begin(), (_o).length());
    }

    ~PartialFileInputStreamParams();

    void
    operator=(const PartialFileInputStreamParams& _o)
    {
        Assign((_o).fileStreamParams(), (_o).begin(), (_o).length());
    }

    bool
    operator==(const PartialFileInputStreamParams& _o) const;

    FileInputStreamParams&
    fileStreamParams()
    {
        return fileStreamParams_;
    }
    const FileInputStreamParams&
    fileStreamParams() const
    {
        return fileStreamParams_;
    }

    uint64_t&
    begin()
    {
        return begin_;
    }
    const uint64_t&
    begin() const
    {
        return begin_;
    }

    uint64_t&
    length()
    {
        return length_;
    }
    const uint64_t&
    length() const
    {
        return length_;
    }

private:
    void
    Init();

    void
    Assign(
            const FileInputStreamParams& _fileStreamParams,
            const uint64_t& _begin,
            const uint64_t& _length);

    FileInputStreamParams fileStreamParams_;
    uint64_t begin_;
    uint64_t length_;
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct TemporaryFileInputStreamParams|
//
namespace mozilla {
namespace ipc {
class TemporaryFileInputStreamParams final
{
private:

public:
    MOZ_IMPLICIT TemporaryFileInputStreamParams();

    MOZ_IMPLICIT TemporaryFileInputStreamParams(
            const uint32_t& _fileDescriptorIndex,
            const uint64_t& _startPos,
            const uint64_t& _endPos)
    {
        Init();
        Assign(_fileDescriptorIndex, _startPos, _endPos);
    }

    MOZ_IMPLICIT TemporaryFileInputStreamParams(const TemporaryFileInputStreamParams& _o)
    {
        Init();
        Assign((_o).fileDescriptorIndex(), (_o).startPos(), (_o).endPos());
    }

    ~TemporaryFileInputStreamParams();

    void
    operator=(const TemporaryFileInputStreamParams& _o)
    {
        Assign((_o).fileDescriptorIndex(), (_o).startPos(), (_o).endPos());
    }

    bool
    operator==(const TemporaryFileInputStreamParams& _o) const;

    uint32_t&
    fileDescriptorIndex()
    {
        return fileDescriptorIndex_;
    }
    const uint32_t&
    fileDescriptorIndex() const
    {
        return fileDescriptorIndex_;
    }

    uint64_t&
    startPos()
    {
        return startPos_;
    }
    const uint64_t&
    startPos() const
    {
        return startPos_;
    }

    uint64_t&
    endPos()
    {
        return endPos_;
    }
    const uint64_t&
    endPos() const
    {
        return endPos_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _fileDescriptorIndex,
            const uint64_t& _startPos,
            const uint64_t& _endPos);

    uint32_t fileDescriptorIndex_;
    uint64_t startPos_;
    uint64_t endPos_;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class InputStreamParams;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct MultiplexInputStreamParams|
//
namespace mozilla {
namespace ipc {
class MultiplexInputStreamParams final
{
private:
    typedef mozilla::ipc::InputStreamParams InputStreamParams;

public:
    MOZ_IMPLICIT MultiplexInputStreamParams();

    MOZ_IMPLICIT MultiplexInputStreamParams(
            const nsTArray<InputStreamParams>& _streams,
            const uint32_t& _currentStream,
            const nsresult& _status,
            const bool& _startedReadingCurrent)
    {
        Init();
        Assign(_streams, _currentStream, _status, _startedReadingCurrent);
    }

    MOZ_IMPLICIT MultiplexInputStreamParams(const MultiplexInputStreamParams& _o)
    {
        Init();
        Assign((_o).streams(), (_o).currentStream(), (_o).status(), (_o).startedReadingCurrent());
    }

    ~MultiplexInputStreamParams();

    void
    operator=(const MultiplexInputStreamParams& _o)
    {
        Assign((_o).streams(), (_o).currentStream(), (_o).status(), (_o).startedReadingCurrent());
    }

    bool
    operator==(const MultiplexInputStreamParams& _o) const;

    nsTArray<InputStreamParams>&
    streams()
    {
        return (*(streams_));
    }
    const nsTArray<InputStreamParams>&
    streams() const
    {
        return (*(streams_));
    }

    uint32_t&
    currentStream()
    {
        return currentStream_;
    }
    const uint32_t&
    currentStream() const
    {
        return currentStream_;
    }

    nsresult&
    status()
    {
        return status_;
    }
    const nsresult&
    status() const
    {
        return status_;
    }

    bool&
    startedReadingCurrent()
    {
        return startedReadingCurrent_;
    }
    const bool&
    startedReadingCurrent() const
    {
        return startedReadingCurrent_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsTArray<InputStreamParams>& _streams,
            const uint32_t& _currentStream,
            const nsresult& _status,
            const bool& _startedReadingCurrent);

    nsTArray<InputStreamParams>* streams_;
    uint32_t currentStream_;
    nsresult status_;
    bool startedReadingCurrent_;
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct RemoteInputStreamParams|
//
namespace mozilla {
namespace ipc {
class RemoteInputStreamParams final
{
private:

public:
    MOZ_IMPLICIT RemoteInputStreamParams();

    MOZ_IMPLICIT RemoteInputStreamParams(const nsID& _id)
    {
        Init();
        Assign(_id);
    }

    MOZ_IMPLICIT RemoteInputStreamParams(const RemoteInputStreamParams& _o)
    {
        Init();
        Assign((_o).id());
    }

    ~RemoteInputStreamParams();

    void
    operator=(const RemoteInputStreamParams& _o)
    {
        Assign((_o).id());
    }

    bool
    operator==(const RemoteInputStreamParams& _o) const;

    nsID&
    id()
    {
        return id_;
    }
    const nsID&
    id() const
    {
        return id_;
    }

private:
    void
    Init();

    void
    Assign(const nsID& _id);

    nsID id_;
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SameProcessInputStreamParams|
//
namespace mozilla {
namespace ipc {
class SameProcessInputStreamParams final
{
private:

public:
    MOZ_IMPLICIT SameProcessInputStreamParams();

    MOZ_IMPLICIT SameProcessInputStreamParams(const intptr_t& _addRefedInputStream)
    {
        Init();
        Assign(_addRefedInputStream);
    }

    MOZ_IMPLICIT SameProcessInputStreamParams(const SameProcessInputStreamParams& _o)
    {
        Init();
        Assign((_o).addRefedInputStream());
    }

    ~SameProcessInputStreamParams();

    void
    operator=(const SameProcessInputStreamParams& _o)
    {
        Assign((_o).addRefedInputStream());
    }

    bool
    operator==(const SameProcessInputStreamParams& _o) const;

    intptr_t&
    addRefedInputStream()
    {
        return addRefedInputStream_;
    }
    const intptr_t&
    addRefedInputStream() const
    {
        return addRefedInputStream_;
    }

private:
    void
    Init();

    void
    Assign(const intptr_t& _addRefedInputStream);

    intptr_t addRefedInputStream_;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class StringInputStreamParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class FileInputStreamParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PartialFileInputStreamParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class TemporaryFileInputStreamParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class BufferedInputStreamParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class MIMEInputStreamParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class MultiplexInputStreamParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class RemoteInputStreamParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class SameProcessInputStreamParams;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union InputStreamParams|
//
namespace mozilla {
namespace ipc {
class InputStreamParams final
{
public:
    enum Type {
        T__None,
        TStringInputStreamParams = 1,
        TFileInputStreamParams,
        TPartialFileInputStreamParams,
        TTemporaryFileInputStreamParams,
        TBufferedInputStreamParams,
        TMIMEInputStreamParams,
        TMultiplexInputStreamParams,
        TRemoteInputStreamParams,
        TSameProcessInputStreamParams,
        T__Last = TSameProcessInputStreamParams
    };

private:
    typedef mozilla::ipc::StringInputStreamParams StringInputStreamParams;
    typedef mozilla::ipc::FileInputStreamParams FileInputStreamParams;
    typedef mozilla::ipc::PartialFileInputStreamParams PartialFileInputStreamParams;
    typedef mozilla::ipc::TemporaryFileInputStreamParams TemporaryFileInputStreamParams;
    typedef mozilla::ipc::BufferedInputStreamParams BufferedInputStreamParams;
    typedef mozilla::ipc::MIMEInputStreamParams MIMEInputStreamParams;
    typedef mozilla::ipc::MultiplexInputStreamParams MultiplexInputStreamParams;
    typedef mozilla::ipc::RemoteInputStreamParams RemoteInputStreamParams;
    typedef mozilla::ipc::SameProcessInputStreamParams SameProcessInputStreamParams;
    typedef StringInputStreamParams StringInputStreamParams__tdef;
    typedef FileInputStreamParams FileInputStreamParams__tdef;
    typedef PartialFileInputStreamParams PartialFileInputStreamParams__tdef;
    typedef TemporaryFileInputStreamParams TemporaryFileInputStreamParams__tdef;
    typedef BufferedInputStreamParams* BufferedInputStreamParams__tdef;
    typedef MIMEInputStreamParams* MIMEInputStreamParams__tdef;
    typedef MultiplexInputStreamParams* MultiplexInputStreamParams__tdef;
    typedef RemoteInputStreamParams RemoteInputStreamParams__tdef;
    typedef SameProcessInputStreamParams SameProcessInputStreamParams__tdef;

    union Value {
        mozilla::AlignedStorage2<StringInputStreamParams> VStringInputStreamParams;
        mozilla::AlignedStorage2<FileInputStreamParams> VFileInputStreamParams;
        mozilla::AlignedStorage2<PartialFileInputStreamParams> VPartialFileInputStreamParams;
        mozilla::AlignedStorage2<TemporaryFileInputStreamParams> VTemporaryFileInputStreamParams;
        BufferedInputStreamParams* VBufferedInputStreamParams;
        MIMEInputStreamParams* VMIMEInputStreamParams;
        MultiplexInputStreamParams* VMultiplexInputStreamParams;
        mozilla::AlignedStorage2<RemoteInputStreamParams> VRemoteInputStreamParams;
        mozilla::AlignedStorage2<SameProcessInputStreamParams> VSameProcessInputStreamParams;
    };

    StringInputStreamParams*
    ptr_StringInputStreamParams()
    {
        return ((mValue).VStringInputStreamParams).addr();
    }
    const StringInputStreamParams*
    constptr_StringInputStreamParams() const
    {
        return ((mValue).VStringInputStreamParams).addr();
    }
    FileInputStreamParams*
    ptr_FileInputStreamParams()
    {
        return ((mValue).VFileInputStreamParams).addr();
    }
    const FileInputStreamParams*
    constptr_FileInputStreamParams() const
    {
        return ((mValue).VFileInputStreamParams).addr();
    }
    PartialFileInputStreamParams*
    ptr_PartialFileInputStreamParams()
    {
        return ((mValue).VPartialFileInputStreamParams).addr();
    }
    const PartialFileInputStreamParams*
    constptr_PartialFileInputStreamParams() const
    {
        return ((mValue).VPartialFileInputStreamParams).addr();
    }
    TemporaryFileInputStreamParams*
    ptr_TemporaryFileInputStreamParams()
    {
        return ((mValue).VTemporaryFileInputStreamParams).addr();
    }
    const TemporaryFileInputStreamParams*
    constptr_TemporaryFileInputStreamParams() const
    {
        return ((mValue).VTemporaryFileInputStreamParams).addr();
    }
    BufferedInputStreamParams*&
    ptr_BufferedInputStreamParams()
    {
        return (mValue).VBufferedInputStreamParams;
    }
    const BufferedInputStreamParams*
    constptr_BufferedInputStreamParams() const
    {
        return (mValue).VBufferedInputStreamParams;
    }
    MIMEInputStreamParams*&
    ptr_MIMEInputStreamParams()
    {
        return (mValue).VMIMEInputStreamParams;
    }
    const MIMEInputStreamParams*
    constptr_MIMEInputStreamParams() const
    {
        return (mValue).VMIMEInputStreamParams;
    }
    MultiplexInputStreamParams*&
    ptr_MultiplexInputStreamParams()
    {
        return (mValue).VMultiplexInputStreamParams;
    }
    const MultiplexInputStreamParams*
    constptr_MultiplexInputStreamParams() const
    {
        return (mValue).VMultiplexInputStreamParams;
    }
    RemoteInputStreamParams*
    ptr_RemoteInputStreamParams()
    {
        return ((mValue).VRemoteInputStreamParams).addr();
    }
    const RemoteInputStreamParams*
    constptr_RemoteInputStreamParams() const
    {
        return ((mValue).VRemoteInputStreamParams).addr();
    }
    SameProcessInputStreamParams*
    ptr_SameProcessInputStreamParams()
    {
        return ((mValue).VSameProcessInputStreamParams).addr();
    }
    const SameProcessInputStreamParams*
    constptr_SameProcessInputStreamParams() const
    {
        return ((mValue).VSameProcessInputStreamParams).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT InputStreamParams() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT InputStreamParams(const StringInputStreamParams& aOther);

    MOZ_IMPLICIT InputStreamParams(const FileInputStreamParams& aOther);

    MOZ_IMPLICIT InputStreamParams(const PartialFileInputStreamParams& aOther);

    MOZ_IMPLICIT InputStreamParams(const TemporaryFileInputStreamParams& aOther);

    MOZ_IMPLICIT InputStreamParams(const BufferedInputStreamParams& aOther);

    MOZ_IMPLICIT InputStreamParams(const MIMEInputStreamParams& aOther);

    MOZ_IMPLICIT InputStreamParams(const MultiplexInputStreamParams& aOther);

    MOZ_IMPLICIT InputStreamParams(const RemoteInputStreamParams& aOther);

    MOZ_IMPLICIT InputStreamParams(const SameProcessInputStreamParams& aOther);

    MOZ_IMPLICIT InputStreamParams(const InputStreamParams& aOther);

    ~InputStreamParams();

    Type
    type() const
    {
        return mType;
    }

    InputStreamParams&
    operator=(const StringInputStreamParams& aRhs);

    InputStreamParams&
    operator=(const FileInputStreamParams& aRhs);

    InputStreamParams&
    operator=(const PartialFileInputStreamParams& aRhs);

    InputStreamParams&
    operator=(const TemporaryFileInputStreamParams& aRhs);

    InputStreamParams&
    operator=(const BufferedInputStreamParams& aRhs);

    InputStreamParams&
    operator=(const MIMEInputStreamParams& aRhs);

    InputStreamParams&
    operator=(const MultiplexInputStreamParams& aRhs);

    InputStreamParams&
    operator=(const RemoteInputStreamParams& aRhs);

    InputStreamParams&
    operator=(const SameProcessInputStreamParams& aRhs);

    InputStreamParams&
    operator=(const InputStreamParams& aRhs);

    bool
    operator==(const StringInputStreamParams& aRhs) const;

    bool
    operator==(const FileInputStreamParams& aRhs) const;

    bool
    operator==(const PartialFileInputStreamParams& aRhs) const;

    bool
    operator==(const TemporaryFileInputStreamParams& aRhs) const;

    bool
    operator==(const BufferedInputStreamParams& aRhs) const;

    bool
    operator==(const MIMEInputStreamParams& aRhs) const;

    bool
    operator==(const MultiplexInputStreamParams& aRhs) const;

    bool
    operator==(const RemoteInputStreamParams& aRhs) const;

    bool
    operator==(const SameProcessInputStreamParams& aRhs) const;

    bool
    operator==(const InputStreamParams& aRhs) const;

    StringInputStreamParams&
    get_StringInputStreamParams()
    {
        AssertSanity(TStringInputStreamParams);
        return (*(ptr_StringInputStreamParams()));
    }
    const StringInputStreamParams&
    get_StringInputStreamParams() const
    {
        AssertSanity(TStringInputStreamParams);
        return (*(constptr_StringInputStreamParams()));
    }
    void
    get(StringInputStreamParams* aOutValue) const;
    operator StringInputStreamParams&()
    {
        return get_StringInputStreamParams();
    }
    operator const StringInputStreamParams&() const
    {
        return get_StringInputStreamParams();
    }

    FileInputStreamParams&
    get_FileInputStreamParams()
    {
        AssertSanity(TFileInputStreamParams);
        return (*(ptr_FileInputStreamParams()));
    }
    const FileInputStreamParams&
    get_FileInputStreamParams() const
    {
        AssertSanity(TFileInputStreamParams);
        return (*(constptr_FileInputStreamParams()));
    }
    void
    get(FileInputStreamParams* aOutValue) const;
    operator FileInputStreamParams&()
    {
        return get_FileInputStreamParams();
    }
    operator const FileInputStreamParams&() const
    {
        return get_FileInputStreamParams();
    }

    PartialFileInputStreamParams&
    get_PartialFileInputStreamParams()
    {
        AssertSanity(TPartialFileInputStreamParams);
        return (*(ptr_PartialFileInputStreamParams()));
    }
    const PartialFileInputStreamParams&
    get_PartialFileInputStreamParams() const
    {
        AssertSanity(TPartialFileInputStreamParams);
        return (*(constptr_PartialFileInputStreamParams()));
    }
    void
    get(PartialFileInputStreamParams* aOutValue) const;
    operator PartialFileInputStreamParams&()
    {
        return get_PartialFileInputStreamParams();
    }
    operator const PartialFileInputStreamParams&() const
    {
        return get_PartialFileInputStreamParams();
    }

    TemporaryFileInputStreamParams&
    get_TemporaryFileInputStreamParams()
    {
        AssertSanity(TTemporaryFileInputStreamParams);
        return (*(ptr_TemporaryFileInputStreamParams()));
    }
    const TemporaryFileInputStreamParams&
    get_TemporaryFileInputStreamParams() const
    {
        AssertSanity(TTemporaryFileInputStreamParams);
        return (*(constptr_TemporaryFileInputStreamParams()));
    }
    void
    get(TemporaryFileInputStreamParams* aOutValue) const;
    operator TemporaryFileInputStreamParams&()
    {
        return get_TemporaryFileInputStreamParams();
    }
    operator const TemporaryFileInputStreamParams&() const
    {
        return get_TemporaryFileInputStreamParams();
    }

    BufferedInputStreamParams&
    get_BufferedInputStreamParams()
    {
        AssertSanity(TBufferedInputStreamParams);
        return (*(ptr_BufferedInputStreamParams()));
    }
    const BufferedInputStreamParams&
    get_BufferedInputStreamParams() const
    {
        AssertSanity(TBufferedInputStreamParams);
        return (*(constptr_BufferedInputStreamParams()));
    }
    void
    get(BufferedInputStreamParams* aOutValue) const;
    operator BufferedInputStreamParams&()
    {
        return get_BufferedInputStreamParams();
    }
    operator const BufferedInputStreamParams&() const
    {
        return get_BufferedInputStreamParams();
    }

    MIMEInputStreamParams&
    get_MIMEInputStreamParams()
    {
        AssertSanity(TMIMEInputStreamParams);
        return (*(ptr_MIMEInputStreamParams()));
    }
    const MIMEInputStreamParams&
    get_MIMEInputStreamParams() const
    {
        AssertSanity(TMIMEInputStreamParams);
        return (*(constptr_MIMEInputStreamParams()));
    }
    void
    get(MIMEInputStreamParams* aOutValue) const;
    operator MIMEInputStreamParams&()
    {
        return get_MIMEInputStreamParams();
    }
    operator const MIMEInputStreamParams&() const
    {
        return get_MIMEInputStreamParams();
    }

    MultiplexInputStreamParams&
    get_MultiplexInputStreamParams()
    {
        AssertSanity(TMultiplexInputStreamParams);
        return (*(ptr_MultiplexInputStreamParams()));
    }
    const MultiplexInputStreamParams&
    get_MultiplexInputStreamParams() const
    {
        AssertSanity(TMultiplexInputStreamParams);
        return (*(constptr_MultiplexInputStreamParams()));
    }
    void
    get(MultiplexInputStreamParams* aOutValue) const;
    operator MultiplexInputStreamParams&()
    {
        return get_MultiplexInputStreamParams();
    }
    operator const MultiplexInputStreamParams&() const
    {
        return get_MultiplexInputStreamParams();
    }

    RemoteInputStreamParams&
    get_RemoteInputStreamParams()
    {
        AssertSanity(TRemoteInputStreamParams);
        return (*(ptr_RemoteInputStreamParams()));
    }
    const RemoteInputStreamParams&
    get_RemoteInputStreamParams() const
    {
        AssertSanity(TRemoteInputStreamParams);
        return (*(constptr_RemoteInputStreamParams()));
    }
    void
    get(RemoteInputStreamParams* aOutValue) const;
    operator RemoteInputStreamParams&()
    {
        return get_RemoteInputStreamParams();
    }
    operator const RemoteInputStreamParams&() const
    {
        return get_RemoteInputStreamParams();
    }

    SameProcessInputStreamParams&
    get_SameProcessInputStreamParams()
    {
        AssertSanity(TSameProcessInputStreamParams);
        return (*(ptr_SameProcessInputStreamParams()));
    }
    const SameProcessInputStreamParams&
    get_SameProcessInputStreamParams() const
    {
        AssertSanity(TSameProcessInputStreamParams);
        return (*(constptr_SameProcessInputStreamParams()));
    }
    void
    get(SameProcessInputStreamParams* aOutValue) const;
    operator SameProcessInputStreamParams&()
    {
        return get_SameProcessInputStreamParams();
    }
    operator const SameProcessInputStreamParams&() const
    {
        return get_SameProcessInputStreamParams();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class InputStreamParams;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalInputStreamParams|
//
namespace mozilla {
namespace ipc {
class OptionalInputStreamParams final
{
public:
    enum Type {
        T__None,
        Tvoid_t = 1,
        TInputStreamParams,
        T__Last = TInputStreamParams
    };

private:
    typedef mozilla::void_t void_t;
    typedef mozilla::ipc::InputStreamParams InputStreamParams;
    typedef void_t void_t__tdef;
    typedef InputStreamParams* InputStreamParams__tdef;

    union Value {
        mozilla::AlignedStorage2<void_t> Vvoid_t;
        InputStreamParams* VInputStreamParams;
    };

    void_t*
    ptr_void_t()
    {
        return ((mValue).Vvoid_t).addr();
    }
    const void_t*
    constptr_void_t() const
    {
        return ((mValue).Vvoid_t).addr();
    }
    InputStreamParams*&
    ptr_InputStreamParams()
    {
        return (mValue).VInputStreamParams;
    }
    const InputStreamParams*
    constptr_InputStreamParams() const
    {
        return (mValue).VInputStreamParams;
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalInputStreamParams() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalInputStreamParams(const void_t& aOther);

    MOZ_IMPLICIT OptionalInputStreamParams(const InputStreamParams& aOther);

    MOZ_IMPLICIT OptionalInputStreamParams(const OptionalInputStreamParams& aOther);

    ~OptionalInputStreamParams();

    Type
    type() const
    {
        return mType;
    }

    OptionalInputStreamParams&
    operator=(const void_t& aRhs);

    OptionalInputStreamParams&
    operator=(const InputStreamParams& aRhs);

    OptionalInputStreamParams&
    operator=(const OptionalInputStreamParams& aRhs);

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const InputStreamParams& aRhs) const;

    bool
    operator==(const OptionalInputStreamParams& aRhs) const;

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    void
    get(void_t* aOutValue) const;
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

    InputStreamParams&
    get_InputStreamParams()
    {
        AssertSanity(TInputStreamParams);
        return (*(ptr_InputStreamParams()));
    }
    const InputStreamParams&
    get_InputStreamParams() const
    {
        AssertSanity(TInputStreamParams);
        return (*(constptr_InputStreamParams()));
    }
    void
    get(InputStreamParams* aOutValue) const;
    operator InputStreamParams&()
    {
        return get_InputStreamParams();
    }
    operator const InputStreamParams&() const
    {
        return get_InputStreamParams();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class OptionalInputStreamParams;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct BufferedInputStreamParams|
//
namespace mozilla {
namespace ipc {
class BufferedInputStreamParams final
{
private:
    typedef mozilla::ipc::OptionalInputStreamParams OptionalInputStreamParams;

public:
    MOZ_IMPLICIT BufferedInputStreamParams();

    MOZ_IMPLICIT BufferedInputStreamParams(
            const OptionalInputStreamParams& _optionalStream,
            const uint32_t& _bufferSize)
    {
        Init();
        Assign(_optionalStream, _bufferSize);
    }

    MOZ_IMPLICIT BufferedInputStreamParams(const BufferedInputStreamParams& _o)
    {
        Init();
        Assign((_o).optionalStream(), (_o).bufferSize());
    }

    ~BufferedInputStreamParams();

    void
    operator=(const BufferedInputStreamParams& _o)
    {
        Assign((_o).optionalStream(), (_o).bufferSize());
    }

    bool
    operator==(const BufferedInputStreamParams& _o) const;

    OptionalInputStreamParams&
    optionalStream()
    {
        return (*(optionalStream_));
    }
    const OptionalInputStreamParams&
    optionalStream() const
    {
        return (*(optionalStream_));
    }

    uint32_t&
    bufferSize()
    {
        return bufferSize_;
    }
    const uint32_t&
    bufferSize() const
    {
        return bufferSize_;
    }

private:
    void
    Init();

    void
    Assign(
            const OptionalInputStreamParams& _optionalStream,
            const uint32_t& _bufferSize);

    OptionalInputStreamParams* optionalStream_;
    uint32_t bufferSize_;
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class OptionalInputStreamParams;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct MIMEInputStreamParams|
//
namespace mozilla {
namespace ipc {
class MIMEInputStreamParams final
{
private:
    typedef mozilla::ipc::OptionalInputStreamParams OptionalInputStreamParams;

public:
    MOZ_IMPLICIT MIMEInputStreamParams();

    MOZ_IMPLICIT MIMEInputStreamParams(
            const OptionalInputStreamParams& _optionalStream,
            const nsCString& _headers,
            const nsCString& _contentLength,
            const bool& _startedReading,
            const bool& _addContentLength)
    {
        Init();
        Assign(_optionalStream, _headers, _contentLength, _startedReading, _addContentLength);
    }

    MOZ_IMPLICIT MIMEInputStreamParams(const MIMEInputStreamParams& _o)
    {
        Init();
        Assign((_o).optionalStream(), (_o).headers(), (_o).contentLength(), (_o).startedReading(), (_o).addContentLength());
    }

    ~MIMEInputStreamParams();

    void
    operator=(const MIMEInputStreamParams& _o)
    {
        Assign((_o).optionalStream(), (_o).headers(), (_o).contentLength(), (_o).startedReading(), (_o).addContentLength());
    }

    bool
    operator==(const MIMEInputStreamParams& _o) const;

    OptionalInputStreamParams&
    optionalStream()
    {
        return (*(optionalStream_));
    }
    const OptionalInputStreamParams&
    optionalStream() const
    {
        return (*(optionalStream_));
    }

    nsCString&
    headers()
    {
        return headers_;
    }
    const nsCString&
    headers() const
    {
        return headers_;
    }

    nsCString&
    contentLength()
    {
        return contentLength_;
    }
    const nsCString&
    contentLength() const
    {
        return contentLength_;
    }

    bool&
    startedReading()
    {
        return startedReading_;
    }
    const bool&
    startedReading() const
    {
        return startedReading_;
    }

    bool&
    addContentLength()
    {
        return addContentLength_;
    }
    const bool&
    addContentLength() const
    {
        return addContentLength_;
    }

private:
    void
    Init();

    void
    Assign(
            const OptionalInputStreamParams& _optionalStream,
            const nsCString& _headers,
            const nsCString& _contentLength,
            const bool& _startedReading,
            const bool& _addContentLength);

    OptionalInputStreamParams* optionalStream_;
    nsCString headers_;
    nsCString contentLength_;
    bool startedReading_;
    bool addContentLength_;
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef InputStreamParams_h
