//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PAPZCTreeManagerParent_h
#define PAPZCTreeManagerParent_h

#include "mozilla/layers/PAPZCTreeManager.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "FrameMetrics.h"
#include "InputData.h"
#include "Units.h"
#include "ipc/nsGUIEventIPC.h"
#include "mozilla/EventForwards.h"
#include "mozilla/GfxMessageUtils.h"
#include "mozilla/MouseEvents.h"
#include "mozilla/layers/APZUtils.h"
#include "mozilla/layers/AsyncDragMetrics.h"
#include "mozilla/layers/GeckoContentController.h"

namespace mozilla {
namespace layers {
class PCompositorBridgeParent;
} // namespace layers
} // namespace mozilla
namespace mozilla {
namespace layers {
class PCompositorBridgeChild;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PCompositorBridgeParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
struct ScrollableLayerGuid;
} // namespace layers
} // namespace mozilla

namespace mozilla {
class WidgetInputEvent;
} // namespace mozilla

namespace mozilla {
class WidgetMouseEventBase;
} // namespace mozilla

namespace mozilla {
class WidgetTouchEvent;
} // namespace mozilla

namespace mozilla {
class WidgetWheelEvent;
} // namespace mozilla

namespace mozilla {
class InputData;
} // namespace mozilla

namespace mozilla {
class MultiTouchInput;
} // namespace mozilla

namespace mozilla {
class MouseInput;
} // namespace mozilla

namespace mozilla {
class PanGestureInput;
} // namespace mozilla

namespace mozilla {
class PinchGestureInput;
} // namespace mozilla

namespace mozilla {
class TapGestureInput;
} // namespace mozilla

namespace mozilla {
class ScrollWheelInput;
} // namespace mozilla

namespace mozilla {
namespace layers {


class PAPZCTreeManagerParent :
    public mozilla::ipc::IProtocol
{
    friend class mozilla::layers::PCompositorBridgeParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::layers::AsyncDragMetrics AsyncDragMetrics;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::InputData InputData;
    typedef mozilla::LayoutDevicePoint LayoutDevicePoint;
    typedef mozilla::layers::MaybeZoomConstraints MaybeZoomConstraints;
    typedef mozilla::Modifiers Modifiers;
    typedef mozilla::MouseInput MouseInput;
    typedef mozilla::MultiTouchInput MultiTouchInput;
    typedef mozilla::PanGestureInput PanGestureInput;
    typedef mozilla::PinchGestureInput PinchGestureInput;
    typedef mozilla::PinchGestureInput::PinchGestureType PinchGestureType;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::WidgetMouseEvent::Reason Reason;
    typedef mozilla::ScrollWheelInput ScrollWheelInput;
    typedef mozilla::layers::ScrollableLayerGuid ScrollableLayerGuid;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::TapGestureInput TapGestureInput;
    typedef mozilla::layers::GeckoContentController::TapType TapType;
    typedef mozilla::layers::TouchBehaviorFlags TouchBehaviorFlags;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::WidgetInputEvent WidgetInputEvent;
    typedef mozilla::WidgetMouseEventBase WidgetMouseEventBase;
    typedef mozilla::WidgetTouchEvent WidgetTouchEvent;
    typedef mozilla::WidgetWheelEvent WidgetWheelEvent;
    typedef mozilla::layers::PCompositorBridgeParent PCompositorBridgeParent;
    typedef mozilla::layers::PCompositorBridgeChild PCompositorBridgeChild;

    typedef PAPZCTreeManager::State State;

    virtual bool
    RecvZoomToRect(
            const ScrollableLayerGuid& aGuid,
            const CSSRect& aRect,
            const uint32_t& Flags) = 0;
    virtual bool
    RecvContentReceivedInputBlock(
            const uint64_t& aInputBlockId,
            const bool& PreventDefault) = 0;
    virtual bool
    RecvSetTargetAPZC(
            const uint64_t& aInputBlockId,
            nsTArray<ScrollableLayerGuid>&& Targets) = 0;
    virtual bool
    RecvUpdateZoomConstraints(
            const ScrollableLayerGuid& aGuid,
            const MaybeZoomConstraints& aConstraints) = 0;
    virtual bool
    RecvCancelAnimation(const ScrollableLayerGuid& aGuid) = 0;
    virtual bool
    RecvAdjustScrollForSurfaceShift(const ScreenPoint& aShift) = 0;
    virtual bool
    RecvSetDPI(const float& aDpiValue) = 0;
    virtual bool
    RecvSetAllowedTouchBehavior(
            const uint64_t& aInputBlockId,
            nsTArray<TouchBehaviorFlags>&& aValues) = 0;
    virtual bool
    RecvStartScrollbarDrag(
            const ScrollableLayerGuid& aGuid,
            const AsyncDragMetrics& aDragMetrics) = 0;
    virtual bool
    RecvSetLongTapEnabled(const bool& aTapGestureEnabled) = 0;
    virtual bool
    RecvProcessTouchVelocity(
            const uint32_t& aTimestampMs,
            const float& aSpeedY) = 0;
    virtual bool
    RecvReceiveMultiTouchInputEvent(
            const MultiTouchInput& aEvent,
            nsEventStatus* aOutStatus,
            MultiTouchInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId) = 0;
    virtual bool
    RecvReceiveMouseInputEvent(
            const MouseInput& aEvent,
            nsEventStatus* aOutStatus,
            MouseInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId) = 0;
    virtual bool
    RecvReceivePanGestureInputEvent(
            const PanGestureInput& aEvent,
            nsEventStatus* aOutStatus,
            PanGestureInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId) = 0;
    virtual bool
    RecvReceivePinchGestureInputEvent(
            const PinchGestureInput& aEvent,
            nsEventStatus* aOutStatus,
            PinchGestureInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId) = 0;
    virtual bool
    RecvReceiveTapGestureInputEvent(
            const TapGestureInput& aEvent,
            nsEventStatus* aOutStatus,
            TapGestureInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId) = 0;
    virtual bool
    RecvReceiveScrollWheelInputEvent(
            const ScrollWheelInput& aEvent,
            nsEventStatus* aOutStatus,
            ScrollWheelInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId) = 0;
    virtual bool
    RecvUpdateWheelTransaction(
            const LayoutDeviceIntPoint& aRefPoint,
            const EventMessage& aEventMessage) = 0;
    virtual bool
    RecvTransformEventRefPoint(
            const LayoutDeviceIntPoint& aRefPoint,
            LayoutDeviceIntPoint* aOutRefPoint,
            ScrollableLayerGuid* aOutTargetGuid) = 0;
    virtual bool
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;

public:
    MOZ_IMPLICIT PAPZCTreeManagerParent();

    virtual ~PAPZCTreeManagerParent();

    PCompositorBridgeParent*
    Manager() const;

    PAPZCTreeManager::State
    state();

    MOZ_MUST_USE bool
    SendHandleTap(
            const TapType& aType,
            const LayoutDevicePoint& point,
            const Modifiers& aModifiers,
            const ScrollableLayerGuid& aGuid,
            const uint64_t& aInputBlockId);

    MOZ_MUST_USE bool
    SendNotifyPinchGesture(
            const PinchGestureType& aType,
            const ScrollableLayerGuid& aGuid,
            const LayoutDeviceCoord& aSpanChange,
            const Modifiers& aModifiers);

    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);

    virtual Result
    OnMessageReceived(const Message& msg__);

    virtual Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__);

    virtual Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__);

    int32_t
    GetProtocolTypeId();

private:
    virtual const char*
    ProtocolName() const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& v__,
            Message* msg__)
    {
        IPC::WriteParam(msg__, v__);
    }

    template<typename T>
    bool
    Read(
            T* v__,
            const Message* msg__,
            PickleIterator* iter__)
    {
        return IPC::ReadParam(msg__, iter__, v__);
    }

    void
    Write(
            const PAPZCTreeManagerParent* v__,
            Message* msg__,
            bool nullable__);

    MOZ_MUST_USE bool
    Read(
            PAPZCTreeManagerParent** v__,
            const Message* msg__,
            PickleIterator* iter__,
            bool nullable__);

    State mState;
};


} // namespace layers
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace layers {
class APZCTreeManagerParent :
    public PAPZCTreeManagerParent
{
    virtual bool
    RecvZoomToRect(
            const ScrollableLayerGuid& aGuid,
            const CSSRect& aRect,
            const uint32_t& Flags);

    virtual bool
    RecvContentReceivedInputBlock(
            const uint64_t& aInputBlockId,
            const bool& PreventDefault);

    virtual bool
    RecvSetTargetAPZC(
            const uint64_t& aInputBlockId,
            nsTArray<ScrollableLayerGuid>&& Targets);

    virtual bool
    RecvUpdateZoomConstraints(
            const ScrollableLayerGuid& aGuid,
            const MaybeZoomConstraints& aConstraints);

    virtual bool
    RecvCancelAnimation(const ScrollableLayerGuid& aGuid);

    virtual bool
    RecvAdjustScrollForSurfaceShift(const ScreenPoint& aShift);

    virtual bool
    RecvSetDPI(const float& aDpiValue);

    virtual bool
    RecvSetAllowedTouchBehavior(
            const uint64_t& aInputBlockId,
            nsTArray<TouchBehaviorFlags>&& aValues);

    virtual bool
    RecvStartScrollbarDrag(
            const ScrollableLayerGuid& aGuid,
            const AsyncDragMetrics& aDragMetrics);

    virtual bool
    RecvSetLongTapEnabled(const bool& aTapGestureEnabled);

    virtual bool
    RecvProcessTouchVelocity(
            const uint32_t& aTimestampMs,
            const float& aSpeedY);

    virtual bool
    RecvReceiveMultiTouchInputEvent(
            const MultiTouchInput& aEvent,
            nsEventStatus* aOutStatus,
            MultiTouchInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId);

    virtual bool
    RecvReceiveMouseInputEvent(
            const MouseInput& aEvent,
            nsEventStatus* aOutStatus,
            MouseInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId);

    virtual bool
    RecvReceivePanGestureInputEvent(
            const PanGestureInput& aEvent,
            nsEventStatus* aOutStatus,
            PanGestureInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId);

    virtual bool
    RecvReceivePinchGestureInputEvent(
            const PinchGestureInput& aEvent,
            nsEventStatus* aOutStatus,
            PinchGestureInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId);

    virtual bool
    RecvReceiveTapGestureInputEvent(
            const TapGestureInput& aEvent,
            nsEventStatus* aOutStatus,
            TapGestureInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId);

    virtual bool
    RecvReceiveScrollWheelInputEvent(
            const ScrollWheelInput& aEvent,
            nsEventStatus* aOutStatus,
            ScrollWheelInput* aOutEvent,
            ScrollableLayerGuid* aOutTargetGuid,
            uint64_t* aOutInputBlockId);

    virtual bool
    RecvUpdateWheelTransaction(
            const LayoutDeviceIntPoint& aRefPoint,
            const EventMessage& aEventMessage);

    virtual bool
    RecvTransformEventRefPoint(
            const LayoutDeviceIntPoint& aRefPoint,
            LayoutDeviceIntPoint* aOutRefPoint,
            ScrollableLayerGuid* aOutTargetGuid);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT APZCTreeManagerParent();
    virtual ~APZCTreeManagerParent();
};
} // namespace layers
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace layers {
bool
APZCTreeManagerParent::RecvZoomToRect(
        const ScrollableLayerGuid& aGuid,
        const CSSRect& aRect,
        const uint32_t& Flags)
{
    return false;
}

bool
APZCTreeManagerParent::RecvContentReceivedInputBlock(
        const uint64_t& aInputBlockId,
        const bool& PreventDefault)
{
    return false;
}

bool
APZCTreeManagerParent::RecvSetTargetAPZC(
        const uint64_t& aInputBlockId,
        nsTArray<ScrollableLayerGuid>&& Targets)
{
    return false;
}

bool
APZCTreeManagerParent::RecvUpdateZoomConstraints(
        const ScrollableLayerGuid& aGuid,
        const MaybeZoomConstraints& aConstraints)
{
    return false;
}

bool
APZCTreeManagerParent::RecvCancelAnimation(const ScrollableLayerGuid& aGuid)
{
    return false;
}

bool
APZCTreeManagerParent::RecvAdjustScrollForSurfaceShift(const ScreenPoint& aShift)
{
    return false;
}

bool
APZCTreeManagerParent::RecvSetDPI(const float& aDpiValue)
{
    return false;
}

bool
APZCTreeManagerParent::RecvSetAllowedTouchBehavior(
        const uint64_t& aInputBlockId,
        nsTArray<TouchBehaviorFlags>&& aValues)
{
    return false;
}

bool
APZCTreeManagerParent::RecvStartScrollbarDrag(
        const ScrollableLayerGuid& aGuid,
        const AsyncDragMetrics& aDragMetrics)
{
    return false;
}

bool
APZCTreeManagerParent::RecvSetLongTapEnabled(const bool& aTapGestureEnabled)
{
    return false;
}

bool
APZCTreeManagerParent::RecvProcessTouchVelocity(
        const uint32_t& aTimestampMs,
        const float& aSpeedY)
{
    return false;
}

bool
APZCTreeManagerParent::RecvReceiveMultiTouchInputEvent(
        const MultiTouchInput& aEvent,
        nsEventStatus* aOutStatus,
        MultiTouchInput* aOutEvent,
        ScrollableLayerGuid* aOutTargetGuid,
        uint64_t* aOutInputBlockId)
{
    return false;
}

bool
APZCTreeManagerParent::RecvReceiveMouseInputEvent(
        const MouseInput& aEvent,
        nsEventStatus* aOutStatus,
        MouseInput* aOutEvent,
        ScrollableLayerGuid* aOutTargetGuid,
        uint64_t* aOutInputBlockId)
{
    return false;
}

bool
APZCTreeManagerParent::RecvReceivePanGestureInputEvent(
        const PanGestureInput& aEvent,
        nsEventStatus* aOutStatus,
        PanGestureInput* aOutEvent,
        ScrollableLayerGuid* aOutTargetGuid,
        uint64_t* aOutInputBlockId)
{
    return false;
}

bool
APZCTreeManagerParent::RecvReceivePinchGestureInputEvent(
        const PinchGestureInput& aEvent,
        nsEventStatus* aOutStatus,
        PinchGestureInput* aOutEvent,
        ScrollableLayerGuid* aOutTargetGuid,
        uint64_t* aOutInputBlockId)
{
    return false;
}

bool
APZCTreeManagerParent::RecvReceiveTapGestureInputEvent(
        const TapGestureInput& aEvent,
        nsEventStatus* aOutStatus,
        TapGestureInput* aOutEvent,
        ScrollableLayerGuid* aOutTargetGuid,
        uint64_t* aOutInputBlockId)
{
    return false;
}

bool
APZCTreeManagerParent::RecvReceiveScrollWheelInputEvent(
        const ScrollWheelInput& aEvent,
        nsEventStatus* aOutStatus,
        ScrollWheelInput* aOutEvent,
        ScrollableLayerGuid* aOutTargetGuid,
        uint64_t* aOutInputBlockId)
{
    return false;
}

bool
APZCTreeManagerParent::RecvUpdateWheelTransaction(
        const LayoutDeviceIntPoint& aRefPoint,
        const EventMessage& aEventMessage)
{
    return false;
}

bool
APZCTreeManagerParent::RecvTransformEventRefPoint(
        const LayoutDeviceIntPoint& aRefPoint,
        LayoutDeviceIntPoint* aOutRefPoint,
        ScrollableLayerGuid* aOutTargetGuid)
{
    return false;
}

void
APZCTreeManagerParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT APZCTreeManagerParent::APZCTreeManagerParent()
{
    MOZ_COUNT_CTOR(APZCTreeManagerParent);
}

MOZ_IMPLICIT APZCTreeManagerParent::~APZCTreeManagerParent()
{
    MOZ_COUNT_DTOR(APZCTreeManagerParent);
}

} // namespace layers
} // namespace mozilla
#endif // if 0

#endif // ifndef PAPZCTreeManagerParent_h
